;NSIS Modern User Interface
;Basic Example Script
;Written by Joost Verburg

;--------------------------------
;Include Modern UI

  !include "MUI.nsh"

;--------------------------------
;General

  ;Name and file
  Name "Instant Content Creator"
  OutFile "Instant Content Creator.exe"

  ;Default installation folder
  InstallDir "$PROGRAMFILES\ICC"
  
  ;Get installation folder from registry if available
  InstallDirRegKey HKCU "Software\ICC" ""

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_LICENSE "license.txt"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Installer Sections

Section "Full install" SecDummy

  SetOutPath "$INSTDIR"
  
  ;ADD YOUR OWN FILES HERE...
  File "ICC.EXE"
  File "ICC.exe.manifest"
  File "license.txt"

  SetOutPath "$INSTDIR\data\"
  File "data\english.dic" 
  File "data\connection.dat" 
  File "data\icc.mdb" 

  SetOutPath "$INSTDIR\templates\"
  File "templates\Default.html" 

  ;Store installation folder
  WriteRegStr HKCU "Software\ICC" "" $INSTDIR

 ;Create shortcuts
  CreateDirectory "$SMPROGRAMS\Instant Content Creator"
  CreateShortCut "$SMPROGRAMS\Instant Content Creator\Instant Content Creator.lnk" "$INSTDIR\icc.exe"
  CreateShortCut "$SMPROGRAMS\Instant Content Creator\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  
  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

SectionEnd

;--------------------------------
;Descriptions

  ;Language strings
  LangString DESC_SecDummy ${LANG_ENGLISH} "Instant Content Creator"

  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${SecDummy} $(DESC_SecDummy)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
;Uninstaller Section

Section "Uninstall"

  ;ADD YOUR OWN FILES HERE...

  Delete "$INSTDIR\ICC.EXE"
  Delete "$INSTDIR\ICC.exe.manifest"
  Delete "$INSTDIR\license.txt"
  Delete "$INSTDIR\Uninstall.exe"

  Delete "$INSTDIR\data\english.dic" 
  Delete "$INSTDIR\data\connection.dat" 
  Delete "$INSTDIR\data\icc.mdb" 
  RMDir "$INSTDIR\data"

  Delete "$INSTDIR\templates\Default.html" 
  RMDir "$INSTDIR\templates"

  RMDir "$INSTDIR"

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\Instant Content Creator\*.*"
  RMDir "$SMPROGRAMS\Instant Content Creator"

  DeleteRegKey /ifempty HKCU "Software\ICC"

SectionEnd