unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, Menus,  ImgList, StdCtrls, Grids,  DB, ADODB, StrUtils,
  janSpeller, Math, Buttons, ToolWin;

const
  fileConnection        = 'data\connection.dat';
  fileDB                = 'data\icc.mdb';
  fileDictionary        = 'data\english.dic';

  folderTemplate        = 'templates\';

  extTemplate           = '.html';

  idNoProject           = -1;
  idNewProject          = 0;
  idNoBody              = -1;

  maxStep               = 13;

  strNoProject          = '[ no project ]';
  strWordCountPrefix    = 'Word Count : ';
  strDefaultTemplate    = 'Default';

  strByline             = 'byline';
  strIntro              = 'intro';
  strClosing            = 'closing';

  colID                 = 0;
  colTitle              = 1;

  sqlGetProjects        = 'SELECT ' +
                          '  * ' +
                          'FROM ' +
                          '  Projects ' +
                          'ORDER BY ' +
                          '  id ';
  sqlAddProject         = 'INSERT INTO ' +
                          '  Projects( ' +
                          '    title, date_created, last_update, product, topics, ' +
                          '    template_format, template_file, x, y, ' +
                          '    introduction, closing, byline, link, keywords, ' +
                          '    description, article ' +
                          '  ) ' +
                          'VALUES( ' +
                          '    :_TITLE_, NOW(), NOW(), :_PRODUCT_, :_TOPICS_, ' +
                          '    :_TEMPLATE_FORMAT_, :_TEMPLATE_FILE_, :_X_, :_Y_, ' +
                          '    :_INTRODUCTION_, :_CLOSING_, :_BYLINE_, :_LINK_, :_KEYWORDS_, ' +
                          '    :_DESCRIPTION_, :_ARTICLE_ ' +
                          '  ) ';
  sqlUpdateProject      = 'UPDATE ' +
                          '  Projects ' +
                          'SET ' +
                          '  title = :_TITLE_, ' +
                          '  last_update = NOW(), ' +
                          '  product = :_PRODUCT_, ' +
                          '  topics = :_TOPICS_, ' +
                          '  template_format = :_TEMPLATE_FORMAT_, ' +
                          '  template_file = :_TEMPLATE_FILE_, ' +
                          '  x = :_X_, ' +
                          '  y = :_Y_, ' +
                          '  introduction = :_INTRODUCTION_, ' +
                          '  closing = :_CLOSING_, ' +
                          '  byline = :_BYLINE_, ' +
                          '  link = :_LINK_, ' +
                          '  keywords = :_KEYWORDS_, ' +
                          '  description = :_DESCRIPTION_, ' +
                          '  article = :_ARTICLE_ ' +
                          'WHERE ' +
                          '  id = :_ID_ ';
  sqlGetBodies          = 'SELECT ' +
                          '  * ' +
                          'FROM ' +
                          '  BodyItems ' +
                          'WHERE ' +
                          '  project_id = :_PROJECT_ID_ ' +
                          'ORDER BY ' +
                          '  itemindex ';
  sqlAddBody            = 'INSERT INTO ' +
                          '  BodyItems( ' +
                          '    project_id, itemindex, title, body ' +
                          '  ) ' +
                          'SELECT ' +
                          '    :_PROJECT_ID_, IIF(MAX(itemindex) IS NULL, 0, MAX(itemindex) + 1), :_TITLE_, :_BODY_ ' +
                          'FROM BodyItems WHERE project_id = :_PROJECT_ID_2_ ';
  sqlUpdateBody         = 'UPDATE ' +
                          '  BodyItems ' +
                          'SET ' +
                          '  title = :_TITLE_, ' +
                          '  body = :_BODY_ ' +
                          'WHERE ' +
                          '  id = :_ID_ ';
  sqlDeleteBody         = 'DELETE FROM ' +
                          '  BodyItems ' +
                          'WHERE ' +
                          '  id = :_ID_ ';
  sqlGetProjectID       = 'SELECT id FROM Projects WHERE title = :_TITLE_ ';
  sqlSetBodyProjectID   = 'UPDATE BodyItems SET project_id = :_PROJECT_ID_ WHERE project_id = 0 ';
  sqlDeleteProject      = 'DELETE FROM Projects WHERE id = :_ID_ ';
  sqlDeleteBodyItems    = 'DELETE FROM BodyItems WHERE project_id = :_ID_ ';
  sqlGetSavedTextList   = 'SELECT id, type, title FROM SavedText WHERE type = :_TYPE_ ORDER BY title ';
  sqlGetSavedText       = 'SELECT id, body FROM SavedText WHERE type = :_TYPE_ AND title = :_TITLE_ ';
  sqlAddSavedText       = 'INSERT INTO SavedText(type, title, body) VALUES(:_TYPE_, :_TITLE_, :_BODY_) ';

type
  TProject = record
    ID              : Integer;
    Title           : String;
    Product         : String;         { step 1 }
    Topics          : TStringList;    { step 2 }
    Template_Format : String;         { step 3 }
    Template_File   : String;         { step 3 }
    X               : String;         { step 4 }
    Y               : String;         { step 4 }
    Introduction    : String;         { step 7 }
    Closing         : String;         { step 8 }
    Byline          : String;         { step 9 }
    Author          : String;         { step 9 }
    Link            : String;         { step 10 }
    Keywords        : TStringList;    { step 11 }
    Description     : String;         { step 12 }
    Article         : TStringList;    { step 13 }
    Modified        : Boolean;        { Needed or not? }
  end;

  TfrmMain = class(TForm)
    barStatus: TStatusBar;
    pnlMain: TPanel;
    lstImages16: TImageList;
    sbxMain: TScrollBox;
    pnlProjectList: TPanel;
    pnlStep1: TPanel;
    pnlStep2: TPanel;
    pnlStep3: TPanel;
    dockBottom: TPanel;
    barPrevNext: TToolbar;
    btnBack: TSpeedButton;
    btnNext: TSpeedButton;
    pnlStep4: TPanel;
    pnlStep5: TPanel;
    pnlStep6: TPanel;
    pnlStep7: TPanel;
    pnlStep8: TPanel;
    pnlStep9: TPanel;
    pnlStep10: TPanel;
    pnlStep11: TPanel;
    pnlStep12: TPanel;
    pnlStep13: TPanel;
    Panel1: TPanel;
    txtTitle0: TStaticText;
    Panel2: TPanel;
    txtTitle1: TStaticText;
    Panel3: TPanel;
    txtTitle2: TStaticText;
    Panel4: TPanel;
    txtTitle3: TStaticText;
    Panel5: TPanel;
    txtTitle4: TStaticText;
    Panel6: TPanel;
    txtTitle5: TStaticText;
    Panel7: TPanel;
    txtTitle6: TStaticText;
    Panel8: TPanel;
    txtTitle7: TStaticText;
    Panel9: TPanel;
    txtTitle8: TStaticText;
    Panel10: TPanel;
    txtTitle9: TStaticText;
    Panel11: TPanel;
    txtTitle10: TStaticText;
    Panel12: TPanel;
    txtTitle11: TStaticText;
    Panel13: TPanel;
    txtTitle12: TStaticText;
    Panel14: TPanel;
    txtTitle13: TStaticText;
    Panel15: TPanel;
    asgProjects: TStringGrid;
    adoConnection: TADOConnection;
    Label1: TLabel;
    edtProduct: TEdit;
    Label2: TLabel;
    edtTopic1: TEdit;
    edtTopic2: TEdit;
    edtTopic3: TEdit;
    edtTopic4: TEdit;
    edtTopic5: TEdit;
    edtTopic6: TEdit;
    edtTopic7: TEdit;
    edtTopic8: TEdit;
    edtTopic9: TEdit;
    edtTopic10: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    btnTemplate1: TRadioButton;
    btnTemplate2: TRadioButton;
    btnTemplate3: TRadioButton;
    btnTemplate4: TRadioButton;
    btnTemplate5: TRadioButton;
    btnTemplate6: TRadioButton;
    btnTemplate7: TRadioButton;
    btnTemplate8: TRadioButton;
    Label14: TLabel;
    Label15: TLabel;
    lblSelectedTemplate: TLabel;
    edtY: TEdit;
    Panel16: TPanel;
    Label16: TLabel;
    Panel17: TPanel;
    asgBody: TStringGrid;
    Label17: TLabel;
    edtStep: TEdit;
    Label18: TLabel;
    memExplain: TMemo;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    memByline: TMemo;
    Label22: TLabel;
    edtLink: TEdit;
    Label23: TLabel;
    edtKeyword1: TEdit;
    edtKeyword2: TEdit;
    edtKeyword3: TEdit;
    edtKeyword4: TEdit;
    edtKeyword5: TEdit;
    edtKeyword6: TEdit;
    edtKeyword7: TEdit;
    edtKeyword8: TEdit;
    edtKeyword9: TEdit;
    edtKeyword10: TEdit;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    edtKeyword11: TEdit;
    edtKeyword12: TEdit;
    Label35: TLabel;
    Label36: TLabel;
    lblProjectFinished: TLabel;
    qryProjects: TADOQuery;
    TBDock2: TPanel;
    TBXToolbar1: TToolbar;
    btnNewProject: TSpeedButton;
    TBDock3: TPanel;
    TBXToolbar2: TToolbar;
    btnNewBody: TSpeedButton;
    TBDock4: TPanel;
    TBXToolbar3: TToolbar;
    btnSave: TSpeedButton;
    btnEditProject: TSpeedButton;
    btnDelProject: TSpeedButton;
    btnEditBody: TSpeedButton;
    btnDeleteBody: TSpeedButton;
    qryAddProject: TADOQuery;
    qryBody: TADOQuery;
    qryAddBody: TADOQuery;
    TBDock5: TPanel;
    TBXToolbar4: TToolbar;
    TBXItem6: TSpeedButton;
    mnuExport: TToolButton;
    btnSpellCheck: TSpeedButton;
    mnuHTMLExport: TMenuItem;
    mnuTXTExport: TMenuItem;
    TBXSeparatorItem2: TMenuItem;
    mnuFTPUpload: TMenuItem;
    dlgSaveHTML: TSaveDialog;
    dlgSaveTXT: TSaveDialog;
    TBXToolbar5: TToolbar;
    janSpeller: TjanSpeller;
    TBXLabelItem2: TLabel;
    lblKeywordDensity: TLabel;
    Label37: TLabel;
    edtX: TEdit;
    edtIntroduction: TMemo;
    edtClosing: TMemo;
    edtDescription: TMemo;
    btn: TSpeedButton;
    Label38: TLabel;
    cobTemplate: TComboBox;
    TBXSeparatorItem3: TToolButton;
    btnPreviewArticle: TSpeedButton;
    btnSaveProject: TSpeedButton;
    dockStep9: TPanel;
    TBXToolbar6: TToolbar;
    mnuSaveByline: TSpeedButton;
    mnuUseSavedByline: TToolButton;
    TBDock6: TPanel;
    TBXToolbar7: TToolbar;
    mnuSaveClosing: TSpeedButton;
    mnuUseSavedClosing: TToolButton;
    TBDock7: TPanel;
    TBXToolbar8: TToolbar;
    mnuSaveIntro: TSpeedButton;
    mnuUseSavedIntro: TToolButton;
    Panel18: TPanel;
    ToolBar1: TToolBar;
    ToolBar2: TToolBar;
    ToolBar3: TToolBar;
    ToolBar4: TToolBar;
    ToolBar5: TToolBar;
    ToolBar6: TToolBar;
    ToolBar7: TToolBar;
    ToolBar8: TToolBar;
    ToolBar9: TToolBar;
    ToolBar10: TToolBar;
    ToolBar11: TToolBar;
    ToolBar12: TToolBar;
    ToolBar13: TToolBar;
    ToolBar14: TToolBar;
    ToolBar15: TToolBar;
    btnProjectList: TSpeedButton;
    lblProjectName: TStaticText;
    btnStep1: TSpeedButton;
    btnStep2: TSpeedButton;
    btnStep3: TSpeedButton;
    btnStep4: TSpeedButton;
    btnStep5: TSpeedButton;
    btnStep6: TSpeedButton;
    btnStep7: TSpeedButton;
    btnStep8: TSpeedButton;
    btnStep9: TSpeedButton;
    btnStep10: TSpeedButton;
    btnStep11: TSpeedButton;
    btnStep12: TSpeedButton;
    ToolBar16: TToolBar;
    btnStep13: TSpeedButton;
    lblWordCount: TStaticText;
    pmExportArticle: TPopupMenu;
    PopupMenu1: TPopupMenu;
    PopupMenu2: TPopupMenu;
    PopupMenu3: TPopupMenu;
    procedure FormCreate(Sender: TObject);
    procedure btnNewProjectClick(Sender: TObject);
    procedure btnStep1bClick(Sender: TObject);
    procedure btnStep2bClick(Sender: TObject);
    procedure btnStep3bClick(Sender: TObject);
    procedure btnStep4bClick(Sender: TObject);
    procedure btnStep5bClick(Sender: TObject);
    procedure btnStep7bClick(Sender: TObject);
    procedure btnStep8bClick(Sender: TObject);
    procedure btnStep9bClick(Sender: TObject);
    procedure btnStep10bClick(Sender: TObject);
    procedure btnStep11bClick(Sender: TObject);
    procedure btnStep12bClick(Sender: TObject);
    procedure btnStep13bClick(Sender: TObject);
    procedure btnBackClick(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnStep6bClick(Sender: TObject);
    procedure edtProductChange(Sender: TObject);
    procedure edtTopicsChange(Sender: TObject);
    procedure btnTemplatesClick(Sender: TObject);
    procedure pnlStep4Enter(Sender: TObject);
    procedure edtYChange(Sender: TObject);
    procedure pnlStep3Enter(Sender: TObject);
    procedure edtStepChange(Sender: TObject);
    procedure memExplainChange(Sender: TObject);
    procedure edtIntroductionChange(Sender: TObject);
    procedure edtClosingChange(Sender: TObject);
    procedure memBylineChange(Sender: TObject);
    procedure edtLinkChange(Sender: TObject);
    procedure edtKeywordsChange(Sender: TObject);
    procedure edtDescriptionChange(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure pnlStep13Enter(Sender: TObject);
    procedure btnProjectListbClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnEditProjectClick(Sender: TObject);
    procedure TBXItem6Click(Sender: TObject);
    procedure btnNewBodyClick(Sender: TObject);
    procedure pnlStep5Enter(Sender: TObject);
    procedure btnDeleteBodyClick(Sender: TObject);
    procedure mnuHTMLExportClick(Sender: TObject);
    procedure mnuTXTExportClick(Sender: TObject);
    procedure btnSpellCheckClick(Sender: TObject);
    procedure mnuFTPUploadClick(Sender: TObject);
    procedure btnDelProjectClick(Sender: TObject);
    procedure btnEditBodyClick(Sender: TObject);
    procedure edtXChange(Sender: TObject);
    procedure btnClick(Sender: TObject);
    procedure cobTemplateChange(Sender: TObject);
    procedure pnlStep1Enter(Sender: TObject);
    procedure pnlStep2Enter(Sender: TObject);
    procedure pnlStep6Enter(Sender: TObject);
    procedure pnlStep7Enter(Sender: TObject);
    procedure pnlStep8Enter(Sender: TObject);
    procedure pnlStep9Enter(Sender: TObject);
    procedure pnlStep10Enter(Sender: TObject);
    procedure pnlStep11Enter(Sender: TObject);
    procedure pnlStep12Enter(Sender: TObject);
    procedure pnlProjectListEnter(Sender: TObject);
    procedure btnPreviewArticleClick(Sender: TObject);
    procedure btnSaveProjectClick(Sender: TObject);
    procedure mnuSaveBylineClick(Sender: TObject);
    procedure mnuSaveClosingClick(Sender: TObject);
    procedure mnuSaveIntroClick(Sender: TObject);
    procedure asgProjectsDblClick(Sender: TObject);
    procedure N11Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Path                : String;
    ActivePanel         : TPanel;
    CurrentBodyItem,
    CurrentStep         : Integer;
    theProject          : TProject;
    ProjectLoading      : Boolean;

    lstSavedIntros      : TStrings;
    lstSavedByline      : TStrings;
    lstSavedClosing     : TStrings;

    procedure SetButtonsDown();

    Function SetActivePanel(newPanel: TPanel): Integer; overload;
    Function SetActivePanel(newPanelID: Integer): Integer; overload;
    Function DoDBConnect(LogActions: Boolean = True): Boolean;
    Function Log(Event: String): Integer;

    Function RefreshProjects: Integer;
    Function RefreshBodies: Integer;
    Function ToggleSteps(Active: Boolean): Integer;
    Function SetProjectTitle(Title: String): Integer;
    Function SaveProject: Boolean;
    Function ClearProject: Boolean;
    Function ClearPanels: Boolean;
    Function QueryToProject: Boolean;
    Function ProjectToPanels: Boolean;

    Function InsertNewBodyItem(aProjectID: Integer; aTitle, aBody: String): Integer;
    Function UpdateOldBodyItem(aItemID: Integer; aTitle, aBody: String): Integer;
    Function StripTags(Page: String; NLStrip: Boolean = False; TitleStrip: Boolean = True): String;
    Function GetWordCount(Article: String): Integer;
    Function SpellCheck(var Data: String): Integer;
    Function GetKeywordDensity(Keyword: String; InfoText: String): Double; overload;
    Function GetKeywordDensity(Keywords: TStringList; InfoText: String): Double; overload;
    Function FormatKeywords(CommaText: String): String;
    Function FormatText(Article: String; CPL: Integer): String;

    Function SetTemplateFiles(Combo: TComboBox; Folder: String; FileMask: String; DefaultIndex: Integer = 0): Integer;
    Function RefreshSavedTextList(aTitles: TStrings; aType: String; menu: TPopupMenu): Integer;
  end;

var
  frmMain: TfrmMain;

implementation

uses Editor, FTPParams, KeyDensity, mshtml_edit;

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
var
  List          : TStringList;

begin

  lstSavedIntros  := TStringList.Create;
  lstSavedClosing := TStringList.Create;
  lstSavedByline  := TStringList.Create;

  Path := ExtractFilePath(Application.ExeName);
  theProject.Topics := TStringList.Create;
  theProject.Keywords := TStringList.Create;
  theProject.Article := TStringList.Create;
  ProjectLoading := False;

  If FileExists(Path + fileConnection) then begin
    List := TStringList.Create;
    List.LoadFromFile(Path + fileConnection);
    If List.Count > 0 then
      adoConnection.ConnectionString := StringReplace(List.Strings[0], '%%DB_PATH%%', Path + fileDB, []);
  end;

  SetActivePanel(pnlProjectList);
  ClearProject;
  CurrentStep := 0;
  CurrentStep := idNoBody;

  If FileExists(Path + fileDictionary) then
    janSpeller.LoadDictionary(Path + fileDictionary);

  DoDBConnect;
end;

Function TfrmMain.Log(Event: String): Integer;
begin
  If Event <> '' then begin
{    lbxLog.Items.BeginUpdate;
    If lbxLog.Count > 1000 then
      lbxLog.Clear;

    lbxLog.Items.Add(DateTimeToStr(Now) + ': ' + Event);
    lbxLog.ItemIndex := lbxLog.Count - 1;
    lbxLog.Items.EndUpdate; }
  end;
  Result := 0;
end;

Function TfrmMain.DoDBConnect(LogActions: Boolean = True): Boolean;
begin
  Result := False;
  If FileExists(Path + fileDB) then begin
    Try
      adoConnection.Connected := True;
      Result := True;
      Log('Connected to the database...'); 
    Except
      On E: Exception do
        Log('Exception: ' + E.Message);
    end;

    If Not adoConnection.Connected then
      Log('Warning: Could not connect to the database');
  end
  else
    Log('Warning: Could not locate the database ("' + Path + fileDB + '")');
end;

Function TfrmMain.SetActivePanel(newPanel: TPanel): Integer;
begin
  Result := 0;
  If Assigned(newPanel) And (newPanel <> ActivePanel) And ((newPanel <> pnlProjectList) Or SaveProject) then begin
    If Assigned(ActivePanel) then begin
      ActivePanel.Visible := False;
      ActivePanel.Align := alTop;
    end;
    ActivePanel := newPanel;
    ActivePanel.Align := alClient;
    ActivePanel.Visible := True;
    CurrentStep := ActivePanel.Tag;
    If frmMain.Visible And ActivePanel.Visible then
      ActivePanel.SetFocus;
  end;
  btnNext.Enabled := CurrentStep < maxStep;
end;

Function TfrmMain.SetActivePanel(newPanelID: Integer): Integer;
var
  Panel           : TPanel;

begin
  If newPanelID = 0 then
    Panel := pnlProjectList
  else
    Panel := frmMain.FindComponent('pnlStep' + IntToStr(newPanelID)) as TPanel;

  Result := SetActivePanel(Panel);
end;

Function TfrmMain.RefreshProjects: Integer;
var
  Index           : Integer;

begin
  Result := 0;
  If Not adoConnection.Connected then begin
    Try
      adoConnection.Open;
      asgProjects.Refresh;
    Except
    end;
  end;

  asgProjects.RowCount := 1;
  If adoConnection.Connected then begin
    With qryProjects do begin
      Close;
      SQL.Clear;
      SQL.Add(sqlGetProjects);
      Try
        Open;
      Except
      end;

      asgProjects.Cells[colID, 0] := 'ID';
      asgProjects.Cells[colTitle, 0] := 'Project Title';

      While Not EOF do begin

        asgProjects.RowCount := asgProjects.RowCount+1;
        asgProjects.FixedRows := 1;

        Index := asgProjects.RowCount - 1;

        asgProjects.Cells[colID, Index] := FieldByname('id').AsString;
        asgProjects.Cells[colTitle, Index] := FieldByname('title').AsString;

        Next;
      end;
    end;
  end;
end;

Function TfrmMain.RefreshBodies: Integer;
var
  Index           : Integer;

begin
  Result := 0;
  If Not adoConnection.Connected then begin
    Try
      adoConnection.Open;
    Except
    end;
  end;

  asgBody.RowCount := 1;
  If adoConnection.Connected then begin
    With qryBody do begin
      Close;
      SQL.Clear;
      SQL.Add(sqlGetBodies);
      Parameters.ParamByName('_PROJECT_ID_').Value := theProject.ID;
      Try
        Open;
      Except
      end;

      asgBody.Cells[ColID, 0] := 'ID';
      asgBody.Cells[ColTitle, 0] := 'Title';

      While Not EOF do begin
        asgBody.RowCount := asgBody.RowCount + 1;
        asgBody.FixedRows := 1;

        Index := asgBody.RowCount - 1;

        asgBody.Cells[colID, Index] := FieldByname('id').AsString;
        asgBody.Cells[colTitle, Index] := FieldByname('title').AsString;

        Next;
      end;
    end;
  end;
end;

procedure TfrmMain.btnNewProjectClick(Sender: TObject);
var
  Title           : String;

begin
  { Add new project... Get the title first... }
  Title := InputBox('New Project', 'Enter Project Title:', '');
  If Title <> '' then begin
    ClearProject;
    ClearPanels;
    theProject.ID := idNewProject;
    SetProjectTitle(Title);
    ToggleSteps(True);
    btnStep1.Click;
    { More? }
  end;
end;

Function TfrmMain.SetProjectTitle(Title: String): Integer;
begin
  Result := 0;
  theProject.Title := Title;
  lblProjectName.Caption := Title;
end;


Function TfrmMain.ToggleSteps(Active: Boolean): Integer;
begin
  Result := 0;
  btnStep1.Enabled := Active;
  btnStep2.Enabled := Active;
  btnStep3.Enabled := Active;
  btnStep4.Enabled := Active;
  btnStep5.Enabled := Active;
  btnStep6.Enabled := Active;
  btnStep7.Enabled := Active;
  btnStep8.Enabled := Active;
  btnStep9.Enabled := Active;
  btnStep10.Enabled := Active;
  btnStep11.Enabled := Active;
  btnStep12.Enabled := Active;
  btnStep13.Enabled := Active;
  barPrevNext.Visible := Active;
  dockBottom.Visible := Active;
  btnNext.Enabled := CurrentStep < maxStep;
end;

procedure TfrmMain.btnStep1bClick(Sender: TObject);
begin
  SetButtonsDown();

  btnStep1.Down := True;
  btnStep1.Font.Style := [fsBold];

  SetActivePanel(pnlStep1);
  If frmMain.Visible And ActivePanel.Visible then
    edtProduct.SetFocus;
end;

procedure TfrmMain.btnStep2bClick(Sender: TObject);
begin
  SetButtonsDown();

  btnStep2.Down := True;
  btnStep2.Font.Style := [fsBold];

  SetActivePanel(pnlStep2);
  If frmMain.Visible And ActivePanel.Visible then
    edtTopic1.SetFocus;
end;

procedure TfrmMain.btnStep3bClick(Sender: TObject);
begin
  SetButtonsDown();

  btnStep3.Down := True;
  btnStep3.Font.Style := [fsBold];

  SetActivePanel(pnlStep3);
{  If frmMain.Visible And ActivePanel.Visible then
    btnTemplate1.SetFocus; }
end;

procedure TfrmMain.btnStep4bClick(Sender: TObject);
begin
  SetButtonsDown();

  btnStep4.Down := True;
  btnStep4.Font.Style := [fsBold];

  SetActivePanel(pnlStep4);
  If frmMain.Visible And ActivePanel.Visible then
    edtX.SetFocus;
end;

procedure TfrmMain.btnStep5bClick(Sender: TObject);
begin
  SetButtonsDown();

  btnStep5.Down := True;
  btnStep5.Font.Style := [fsBold];

  SetActivePanel(pnlStep5);
  If frmMain.Visible And ActivePanel.Visible then
    asgBody.SetFocus;
end;

procedure TfrmMain.btnStep6bClick(Sender: TObject);
begin
  SetButtonsDown();

  btnStep6.Down := True;
  btnStep6.Font.Style := [fsBold];

  SetActivePanel(pnlStep6);
  If frmMain.Visible And ActivePanel.Visible then
    edtStep.SetFocus;
end;

procedure TfrmMain.btnStep7bClick(Sender: TObject);
begin
  SetButtonsDown();

  btnStep7.Down := True;
  btnStep7.Font.Style := [fsBold];

  SetActivePanel(pnlStep7);
  If frmMain.Visible And ActivePanel.Visible then
    edtIntroduction.SetFocus;
end;

procedure TfrmMain.btnStep8bClick(Sender: TObject);
begin
  SetButtonsDown();

  btnStep8.Down := True;
  btnStep8.Font.Style := [fsBold];

  SetActivePanel(pnlStep8);
  If frmMain.Visible And ActivePanel.Visible then
    edtClosing.SetFocus;
end;

procedure TfrmMain.btnStep9bClick(Sender: TObject);
begin
  SetButtonsDown();

  btnStep9.Down := True;
  btnStep9.Font.Style := [fsBold];

  SetActivePanel(pnlStep9);
  If frmMain.Visible And ActivePanel.Visible then
    memByline.SetFocus;
end;

procedure TfrmMain.btnStep10bClick(Sender: TObject);
begin
  SetButtonsDown();

  btnStep10.Down := True;
  btnStep10.Font.Style := [fsBold];

  SetActivePanel(pnlStep10);
  If frmMain.Visible And ActivePanel.Visible then
    edtLink.SetFocus;
end;

procedure TfrmMain.btnStep11bClick(Sender: TObject);
begin
  SetButtonsDown();

  btnStep11.Down := True;
  btnStep11.Font.Style := [fsBold];

  SetActivePanel(pnlStep11);
  If frmMain.Visible And ActivePanel.Visible then
    edtKeyword1.SetFocus;
end;

procedure TfrmMain.btnStep12bClick(Sender: TObject);
begin
  SetButtonsDown();

  btnStep12.Down := True;
  btnStep12.Font.Style := [fsBold];

  SetActivePanel(pnlStep12);
  If frmMain.Visible And ActivePanel.Visible then
    edtDescription.SetFocus;
end;

procedure TfrmMain.btnStep13bClick(Sender: TObject);
begin
  SetButtonsDown();

  btnStep13.Down := True;
  btnStep13.Font.Style := [fsBold];

  SetActivePanel(pnlStep13);
  btnNext.Enabled := CurrentStep < maxStep;
end;

procedure TfrmMain.btnBackClick(Sender: TObject);
var
  Button          : TSpeedButton;

begin
  If CurrentStep > 0 then begin
    Dec(CurrentStep);
    If CurrentStep = 6 then { Step 6 is accessed using `New Body` button... }
      Dec(CurrentStep);
    Button := frmMain.FindComponent('btnStep' + IntToStr(CurrentStep)) as TSpeedButton;
    If Assigned(Button) then
      Button.Click
    else begin
      If CurrentStep = 0 then begin
        If ClearProject then begin
          ClearPanels;
          SetActivePanel(CurrentStep);
          ToggleSteps(False);
        end;
      end
      else
        SetActivePanel(CurrentStep);
    end;
  end;
  btnNext.Enabled := CurrentStep < maxStep;
end;

Function TfrmMain.UpdateOldBodyItem(aItemID: Integer; aTitle, aBody: String): Integer;
begin
  Result := 0;
  If (Trim(aTitle) <> '') And (Trim(aBody) <> '') then begin
    With qryAddBody do begin
      Close;
      SQL.Clear;
      Parameters.Clear;
      SQL.Add(sqlUpdateBody);
      Parameters.ParamByName('_ID_').Value := aItemID;
      Parameters.ParamByName('_TITLE_').Value := aTitle;
      Parameters.ParamByName('_BODY_').Value := aBody;
      Try
        ExecSQL;
      Except
        On E: Exception do
          MessageDlg(E.Message, mtError, [mbOK], 0);
      end;
    end;
  end;
end;

Function TfrmMain.InsertNewBodyItem(aProjectID: Integer; aTitle, aBody: String): Integer;
begin
  Result := 0;
  If (Trim(aTitle) <> '') And (Trim(aBody) <> '') then begin
    With qryAddBody do begin
      Close;
      SQL.Clear;
      Parameters.Clear;
      SQL.Add(sqlAddBody);
      Parameters.ParamByName('_PROJECT_ID_').Value := aProjectID;
      Parameters.ParamByName('_TITLE_').Value := aTitle;
      Parameters.ParamByName('_BODY_').Value := aBody;
      Parameters.ParamByName('_PROJECT_ID_2_').Value := aProjectID;
      Try
        ExecSQL;
      Except
        On E: Exception do
          MessageDlg(E.Message, mtError, [mbOK], 0);
      end;
    end;
  end;
end;

procedure TfrmMain.btnNextClick(Sender: TObject);
var
  Button          : TSpeedButton;

begin
  If CurrentStep < maxStep then begin
    If CurrentStep = 6 then begin { Save the new item and get back to the list of body items... }
      If CurrentBodyItem > 0 then
        UpdateOldBodyItem(CurrentBodyItem, edtStep.Text, memExplain.Text)
      else
        InsertNewBodyItem(theProject.ID, edtStep.Text, memExplain.Text);
      CurrentStep := 5;
      CurrentBodyItem := idNoBody;
    end
    else begin
      Inc(CurrentStep);
      If CurrentStep = 6 then { Step 6 is accessed using `New Body` button... }
        Inc(CurrentStep);
    end;
    Button := frmMain.FindComponent('btnStep' + IntToStr(CurrentStep)) as TSpeedButton;
    If Assigned(Button) then
      Button.Click
  end;
  btnNext.Enabled := CurrentStep < maxStep;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  If Assigned(theProject.Topics) then
    FreeAndNil(theProject.Topics);
  If Assigned(theProject.Keywords) then
    FreeAndNil(theProject.Keywords);
  If Assigned(theProject.Article) then
    FreeAndNil(theProject.Article);
end;

Function TfrmMain.SaveProject: Boolean;
begin
  { Save... }
  If (theProject.Modified) And (theProject.ID <> idNoProject) then begin
    Result := False;
    If theProject.ID = idNewProject then begin
      { New project - INSERT... }
      With qryAddProject do begin
        Close;
        SQL.Clear;
        Parameters.Clear;
        SQL.Add(sqlAddProject);
        Parameters.ParamByName('_TITLE_').Value := theProject.Title;
        Parameters.ParamByName('_PRODUCT_').Value := theProject.Product;
        Parameters.ParamByName('_TOPICS_').Value := theProject.Topics.Text;
        Parameters.ParamByName('_TEMPLATE_FORMAT_').Value := theProject.Template_Format;
        Parameters.ParamByName('_TEMPLATE_FILE_').Value := theProject.Template_File;
        Parameters.ParamByName('_X_').Value := theProject.X;
        Parameters.ParamByName('_Y_').Value := theProject.Y;
{        Parameters.ParamByName('_TIP_').Value := theProject.Tip;
        Parameters.ParamByName('_REASON_').Value := theProject.Reason; }
        Parameters.ParamByName('_INTRODUCTION_').Value := theProject.Introduction;
        Parameters.ParamByName('_CLOSING_').Value := theProject.Closing;
        Parameters.ParamByName('_BYLINE_').Value := theProject.Byline;
        Parameters.ParamByName('_LINK_').Value := theProject.Link;
        Parameters.ParamByName('_KEYWORDS_').Value := theProject.Keywords.Text;
        Parameters.ParamByName('_DESCRIPTION_').Value := theProject.Description;
        Parameters.ParamByName('_ARTICLE_').Value := theProject.Article.Text;
        Try
          ExecSQL;
          Result := True;
          theProject.Modified := False;
        Except
          On E: Exception do
            MessageDlg(E.Message, mtWarning, [mbOK], 0);
        end;

        Close;
        SQL.Clear;
        Parameters.Clear;
        SQL.Add(sqlGetProjectID);
        Parameters.ParamByName('_TITLE_').Value := theProject.Title;
        Try
          Open;
          theProject.ID := FieldByName('id').Value;
        Except
        end;

        If theProject.ID <> idNewProject then begin
          Close;
          SQL.Clear;
          Parameters.Clear;
          SQL.Add(sqlSetBodyProjectID);
          Parameters.ParamByName('_PROJECT_ID_').Value := theProject.ID;
          Try
            ExecSQL;
          Except
          end;
        end;

      end;
    end
    else begin
      { Old project - UPDATE... }
      With qryAddProject do begin
        Close;
        SQL.Clear;
        Parameters.Clear;
        SQL.Add(sqlUpdateProject);
        Parameters.ParamByName('_TITLE_').Value := theProject.Title;
        Parameters.ParamByName('_PRODUCT_').Value := theProject.Product;
        Parameters.ParamByName('_TOPICS_').Value := theProject.Topics.Text;
        Parameters.ParamByName('_TEMPLATE_FORMAT_').Value := theProject.Template_Format;
        Parameters.ParamByName('_TEMPLATE_FILE_').Value := theProject.Template_File;
        Parameters.ParamByName('_X_').Value := theProject.X;
        Parameters.ParamByName('_Y_').Value := theProject.Y;
{        Parameters.ParamByName('_TIP_').Value := theProject.Tip;
        Parameters.ParamByName('_REASON_').Value := theProject.Reason; }
        Parameters.ParamByName('_INTRODUCTION_').Value := theProject.Introduction;
        Parameters.ParamByName('_CLOSING_').Value := theProject.Closing;
        Parameters.ParamByName('_BYLINE_').Value := theProject.Byline;
        Parameters.ParamByName('_LINK_').Value := theProject.Link;
        Parameters.ParamByName('_KEYWORDS_').Value := theProject.Keywords.Text;
        Parameters.ParamByName('_DESCRIPTION_').Value := theProject.Description;
        Parameters.ParamByName('_ARTICLE_').Value := theProject.Article.Text;
        Parameters.ParamByName('_ID_').Value := theProject.ID;
        Try
          ExecSQL;
          Result := True;
          theProject.Modified := False;
        Except
          On E: Exception do
            MessageDlg(E.Message, mtWarning, [mbOK], 0);
        end;
      end;
    end;
  end
  else
    Result := True;
end;

Function TfrmMain.ClearProject: Boolean;
var
  Proceed       : Boolean;

begin
  Proceed := True;
(*  If theProject.Modified then begin
    Case MessageDlg('You have unsaved changes! Save them?', mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
      mrYes: SaveProject;
      mrNo: { Nothing... } ;
      mrCancel: Proceed := False;
    end;
  end; *)

  If Proceed then begin
    theProject.ID := idNoProject;
    theProject.Title := strNoProject;
    lblProjectName.Caption := theProject.Title;
    theProject.Product := '';
    theProject.Topics.Text := '';
    theProject.Template_Format := '';
    theProject.Template_File := 'Default';
    theProject.X := '';
    theProject.Y := '';
    theProject.Introduction := '';
    theProject.Closing := '';
    theProject.Byline := '';
    theProject.Author := '';
    theProject.Link := '';
    theProject.Keywords.Text:= '';
    theProject.Description := '';
    theProject.Article.Text := '';
    theProject.Modified := False;
  end;

  Result := Proceed;
end;

Function TfrmMain.ClearPanels: Boolean;
var
  Cnt           : Integer;
  Edit          : TEdit;

begin
  ProjectLoading := True;

  Result := True;
  SetProjectTitle(strNoproject);
  edtProduct.Text := '';
  Cnt := 0;
  While Cnt < 10 do begin
    Edit := FindComponent('edtTopic' + IntToStr(Cnt + 1)) as TEdit;
    If Assigned(Edit) then
      Edit.Text := '';
    Inc(Cnt);
  end;
  cobTemplate.ItemIndex := 0;
  edtX.Text := '';
  edtY.Text := '';
{  edtStep.Text := '';
  memExplain.Text := ''; }
  edtIntroduction.Text := '';
  edtClosing.Text := '';
  memByLine.Text := '';
  edtLink.Text := '';
  Cnt := 0;
  While Cnt < 12 do begin
    Edit := FindComponent('edtKeyword' + IntToStr(Cnt + 1)) as TEdit;
    If Assigned(Edit) then
      Edit.Text := '';
    Inc(Cnt);
  end;
  edtDescription.Text := theProject.Description;
{
  theProject.Template_Format := qryProjects.FieldByname('template_format').AsString;
}
  ProjectLoading := False;
end;

Function TfrmMain.QueryToProject: Boolean;
var
  List            : TStringList;

begin
  Result := True;
  theProject.ID := qryProjects.FieldByname('id').Value;
  theProject.Title := qryProjects.FieldByname('title').AsString;
  theProject.Product := qryProjects.FieldByname('product').AsString;
  theProject.Topics.Text := qryProjects.FieldByname('topics').AsString;
  theProject.Template_Format := qryProjects.FieldByname('template_format').AsString;
  theProject.Template_File := qryProjects.FieldByname('template_file').AsString;
  theProject.X := qryProjects.FieldByname('x').AsString;
  theProject.Y := qryProjects.FieldByname('y').AsString;
{  theProject.Body_ID := qryProjects.FieldByname('body_id').Value;
  theProject.Tip := qryProjects.FieldByname('tip').AsString;
  theProject.Reason := qryProjects.FieldByname('reason').AsString; }
  theProject.Introduction := qryProjects.FieldByname('introduction').AsString;
  theProject.Closing := qryProjects.FieldByname('closing').AsString;
  theProject.Byline := qryProjects.FieldByname('byline').AsString;

  { FIX: Author is the first line of Byline... }
  List := TStringList.Create;
  List.Text := theProject.Byline;
  If List.Count > 0 then
    theProject.Author := List.Strings[0]
  else
    theProject.Author := '';
  FreeAndNil(List);

  theProject.Link := qryProjects.FieldByname('link').AsString;
  theProject.Keywords.Text:= qryProjects.FieldByname('keywords').AsString;
  theProject.Description := qryProjects.FieldByname('description').AsString;
  theProject.Article.Text := qryProjects.FieldByname('article').AsString;
  theProject.Modified := False;
end;

Function TfrmMain.ProjectToPanels: Boolean;
var
  Cnt           : Integer;
  Edit          : TEdit;

begin
  ProjectLoading := True;

  Result := True;
  SetProjectTitle(theProject.Title);
  edtProduct.Text := theProject.Product;
  Cnt := 0;
  While Cnt < 10 do begin
    Edit := FindComponent('edtTopic' + IntToStr(Cnt + 1)) as TEdit;
    If Assigned(Edit) then begin
      If Cnt < theProject.Topics.Count then
        Edit.Text := theProject.Topics.Strings[Cnt]
      else
        Edit.Text := '';
    end;
    Inc(Cnt);
  end;
  cobTemplate.ItemIndex := Max(0, cobTemplate.Items.IndexOf(theProject.Template_File));
  edtX.Text := theProject.X;
  edtY.Text := theProject.Y;
{  edtStep.Text := theProject.Tip;
  memExplain.Text := theProject.Reason; }
  edtIntroduction.Text := theProject.Introduction;
  edtClosing.Text := theProject.Closing;
  memByLine.Text := theProject.Byline;
  edtLink.Text := theProject.Link;
  Cnt := 0;
  While Cnt < 12 do begin
    Edit := FindComponent('edtKeyword' + IntToStr(Cnt + 1)) as TEdit;
    If Assigned(Edit) then begin
      If Cnt < theProject.Keywords.Count then
        Edit.Text := theProject.Keywords.Strings[Cnt]
      else
        Edit.Text := '';
    end;
    Inc(Cnt);
  end;
  edtDescription.Text := theProject.Description;
{
  theProject.Template_Format := qryProjects.FieldByname('template_format').AsString;
}
  ProjectLoading := False;
end;

procedure TfrmMain.edtProductChange(Sender: TObject);
begin
  If Not ProjectLoading then begin
    theProject.Product := edtProduct.Text;
    theProject.Modified := True;
  end;
end;

procedure TfrmMain.edtTopicsChange(Sender: TObject);
begin
  If Not ProjectLoading then begin
    theProject.Topics.Clear;
    theProject.Topics.Add(edtTopic1.Text);
    theProject.Topics.Add(edtTopic2.Text);
    theProject.Topics.Add(edtTopic3.Text);
    theProject.Topics.Add(edtTopic4.Text);
    theProject.Topics.Add(edtTopic5.Text);
    theProject.Topics.Add(edtTopic6.Text);
    theProject.Topics.Add(edtTopic7.Text);
    theProject.Topics.Add(edtTopic8.Text);
    theProject.Topics.Add(edtTopic9.Text);
    theProject.Topics.Add(edtTopic10.Text);
    theProject.Modified := True;
  end;
end;

procedure TfrmMain.btnTemplatesClick(Sender: TObject);
begin
  theProject.Modified := theProject.Template_Format <> (Sender as TRadioButton).Caption;
  theProject.Template_Format := (Sender as TRadioButton).Caption;
end;

procedure TfrmMain.pnlStep4Enter(Sender: TObject);
begin
  lblSelectedTemplate.Caption := theProject.Template_Format;
  If Assigned(pnlStep13.OnEnter) then
    pnlStep13.OnEnter(Sender);
end;

procedure TfrmMain.edtYChange(Sender: TObject);
begin
  If Not ProjectLoading then begin
    theProject.Y := edtY.Text;
    theProject.Modified := True;
  end;
end;

Function TfrmMain.SetTemplateFiles(Combo: TComboBox; Folder: String; FileMask: String; DefaultIndex: Integer = 0): Integer;
var
  procSave          : TNotifyEvent;
  SearchRec         : TSearchRec;
  Temp              : String;

begin
  Result := 0;
  If Assigned(Combo) then begin
    procSave := Combo.OnChange;
    Combo.OnChange := nil;
    Combo.Items.Clear;
    Combo.Items.Add(strDefaultTemplate);
    If FindFirst(Folder + FileMask, faAnyFile, SearchRec) = 0 then begin
      Temp := ExtractFileName(SearchRec.Name);
      Temp := Trim(Copy(Temp, 1, Length(Temp) - Length(ExtractFileExt(Temp))));
      If Temp <> strDefaultTemplate then
        Combo.Items.Add(Temp);
      While FindNext(SearchRec) = 0 do begin
        Temp := ExtractFileName(SearchRec.Name);
        Temp := Trim(Copy(Temp, 1, Length(Temp) - Length(ExtractFileExt(Temp))));
        If Temp <> strDefaultTemplate then
          Combo.Items.Add(Temp);
      end;
      FindClose(SearchRec);
    end;
    Combo.ItemIndex := Min(DefaultIndex, Combo.Items.Count - 1);
    Combo.OnChange := procSave;
  end;
end;

procedure TfrmMain.pnlStep3Enter(Sender: TObject);
var
  Found         : Boolean;
  Cnt           : Integer;
  Radio         : TRadioButton;

begin
  { Retrieve available template files... }
  SetTemplateFiles(cobTemplate, Path + folderTemplate, '*' + extTemplate, 0);
  cobTemplate.ItemIndex := Max(0, cobTemplate.Items.IndexOf(theProject.Template_File));

  If theProject.Template_Format = '' then begin
    { The default template... }
    theProject.Template_Format := btnTemplate1.Caption;
  end
  else begin
    Found := False;
    Cnt := 0;
    While (Not Found) And (Cnt < frmMain.ComponentCount) do begin
      If frmMain.Components[Cnt] is TRadioButton then
        Radio := frmMain.Components[Cnt] as TRadioButton
      else
        Radio := nil;

      If Assigned(Radio) then
        Found := Radio.Caption = theProject.Template_Format;

      If Found then
        Radio.Checked := True
      else
        Inc(Cnt);
    end;
  end;

  If (theProject.Article.Text <> '') And Assigned(pnlStep13.OnEnter) then
    pnlStep13.OnEnter(Sender);
end;

procedure TfrmMain.edtStepChange(Sender: TObject);
begin
  If Not ProjectLoading then begin
{    theProject.Tip := edtStep.Text;
    theProject.Modified := True; }
  end;
end;

procedure TfrmMain.memExplainChange(Sender: TObject);
begin
  If Not ProjectLoading then begin
{    theProject.Reason := memExplain.Text;
    theProject.Modified := True; }
  end;
end;

procedure TfrmMain.edtIntroductionChange(Sender: TObject);
begin
  If Not ProjectLoading then begin
    theProject.Introduction := edtIntroduction.Text;
    theProject.Modified := True;
  end;
end;

procedure TfrmMain.edtClosingChange(Sender: TObject);
begin
  If Not ProjectLoading then begin
    theProject.Closing := edtClosing.Text;
    theProject.Modified := True;
  end;
end;

procedure TfrmMain.memBylineChange(Sender: TObject);
begin
  If Not ProjectLoading then begin
    theProject.Byline := memByline.Text;
    If memByline.Lines.Count > 0 then
      theProject.Author := memByLine.Lines.Strings[0]
    else
      theProject.Author := '';
    theProject.Modified := True;
  end;
end;

procedure TfrmMain.edtLinkChange(Sender: TObject);
begin
  If Not ProjectLoading then begin
    theProject.Link := edtLink.Text;
    theProject.Modified := True;
  end;
end;

procedure TfrmMain.edtKeywordsChange(Sender: TObject);
begin
  If Not ProjectLoading then begin
    theProject.Keywords.Clear;
    theProject.Keywords.Add(edtKeyword1.Text);
    theProject.Keywords.Add(edtKeyword2.Text);
    theProject.Keywords.Add(edtKeyword3.Text);
    theProject.Keywords.Add(edtKeyword4.Text);
    theProject.Keywords.Add(edtKeyword5.Text);
    theProject.Keywords.Add(edtKeyword6.Text);
    theProject.Keywords.Add(edtKeyword7.Text);
    theProject.Keywords.Add(edtKeyword8.Text);
    theProject.Keywords.Add(edtKeyword9.Text);
    theProject.Keywords.Add(edtKeyword10.Text);
    theProject.Keywords.Add(edtKeyword11.Text);
    theProject.Keywords.Add(edtKeyword12.Text);
    theProject.Modified := True;
  end;
end;

procedure TfrmMain.edtDescriptionChange(Sender: TObject);
begin
  If Not ProjectLoading then begin
    theProject.Description := edtDescription.Text;
    theProject.Modified := True;
  end;
end;

procedure TfrmMain.btnSaveClick(Sender: TObject);
begin
  If SaveProject then
    btnProjectList.Click;
end;

procedure TfrmMain.pnlStep13Enter(Sender: TObject);
const
  strStart          = '%%_LIST_BEGIN_%%';
  strEnd            = '%%_LIST_END_%%';

var
{  TopicCount, }
  Cnt,
  idxStart,
  idxEnd            : Integer;
  oldItem,
  newItem,
  FileName,
  tmpTitle,
  Body              : String;
  List              : TStringList;

begin
{  FileName := Path + folderTemplate + theProject.Template_Format + extTemplate; }
  FileName := Path + folderTemplate + theProject.Template_File + extTemplate;
  If FileExists(FileName) then begin
    List := TStringList.Create;
    List.LoadFromFile(FileName);
    Body := List.Text;
    FreeAndNil(List);

    { Generate the article: theProject.Article...  }
    If Body <> '' then begin
      { Body items first... }
{      TopicCount := 0; }
      idxStart := Pos(strStart, UpperCase(Body));
      idxEnd := PosEx(strEnd, UpperCase(Body), idxStart);
      If (idxStart > 0) And (idxEnd > idxStart) then begin
        { Add items... }
        oldItem := Copy(Body, idxStart, idxEnd - idxStart + Length(strEnd));
        With qryBody do begin
          Close;
          SQL.Clear;
          Parameters.Clear;
          SQL.Add(sqlGetBodies);
          Parameters.ParamByName('_PROJECT_ID_').Value := theProject.ID;
          Try
            Open;
          Except
            On E: Exception do
              MessageDlg(E.Message, mtError, [mbOK], 0);
          end;

          Cnt := 1;
          While Not EOF do begin
{            Inc(TopicCount); }

            newItem := oldItem;
            newItem := StringReplace(newItem, '%%_ITEM_INDEX_%%', IntToStr(Cnt), [rfReplaceAll, rfIgnoreCase]);
            newItem := StringReplace(newItem, '%%_ITEM_TITLE_%%', FieldByName('title').AsString, [rfReplaceAll, rfIgnoreCase]);
            newItem := StringReplace(newItem, '%%_ITEM_BODY_%%', FieldByName('body').AsString, [rfReplaceAll, rfIgnoreCase]);
            { Remove the tags... }
            newItem := StringReplace(newItem, strStart, '', [rfReplaceAll, rfIgnoreCase]);
            newItem := StringReplace(newItem, strEnd, '', [rfReplaceAll, rfIgnoreCase]);
            { Insert it into the article... }
            Body := StringReplace(Body, oldItem, newItem + ' ' + oldItem, [rfIgnoreCase]);
            { Next... }
            Inc(Cnt);
            Next;
          end;
          { Remove the last tag... }
          Body := StringReplace(Body, oldItem, '', [rfIgnoreCase]);
        end;
      end;

      { The rest of the variables... }
      tmpTitle := theProject.Template_Format;
      tmpTitle := StringReplace(tmpTitle, '(X)', '%%_X_%%', [rfIgnoreCase, rfReplaceAll]);
      tmpTitle := StringReplace(tmpTitle, '(Y)', '%%_Y_%%', [rfIgnoreCase, rfReplaceAll]);
      Body := StringReplace(Body, '%%_TITLE_%%', tmpTitle {theProject.Title}, [rfIgnoreCase, rfReplaceAll]);
      Body := StringReplace(Body, '%%_PRODUCT_%%', theProject.Product, [rfIgnoreCase, rfReplaceAll]);
      Body := StringReplace(Body, '%%_TOPICS_%%', theProject.Topics.CommaText, [rfIgnoreCase, rfReplaceAll]);
{      Body := StringReplace(Body, '%%_X_%%', IntToStr(TopicCount), [rfIgnoreCase, rfReplaceAll]); }
      Body := StringReplace(Body, '%%_X_%%', theProject.X, [rfIgnoreCase, rfReplaceAll]); 
      Body := StringReplace(Body, '%%_Y_%%', theProject.Y, [rfIgnoreCase, rfReplaceAll]);
{      Body := StringReplace(Body, '%%_REASON_%%', theProject.Reason, [rfIgnoreCase, rfReplaceAll]); }
      Body := StringReplace(Body, '%%_INTRODUCTION_%%', theProject.Introduction, [rfIgnoreCase, rfReplaceAll]);
      Body := StringReplace(Body, '%%_CLOSING_%%', theProject.Closing, [rfIgnoreCase, rfReplaceAll]);
      Body := StringReplace(Body, '%%_BYLINE_%%', theProject.Byline, [rfIgnoreCase, rfReplaceAll]);
      Body := StringReplace(Body, '%%_AUTHOR_%%', theProject.Author, [rfIgnoreCase, rfReplaceAll]);
{      Body := StringReplace(Body, '%%_LINK_%%', theProject.Link, [rfIgnoreCase, rfReplaceAll]); }
      Body := StringReplace(Body, '%%_LINK_%%', '<A HREF="' + theProject.Link + '">' + theProject.Link + '</A>', [rfIgnoreCase, rfReplaceAll]); 
      Body := StringReplace(Body, '%%_KEYWORDS_%%', FormatKeywords(theProject.Keywords.CommaText), [rfIgnoreCase, rfReplaceAll]);
      Body := StringReplace(Body, '%%_DESCRIPTION_%%', theProject.Description, [rfIgnoreCase, rfReplaceAll]);
    end;
    theProject.Article.Text := Body;

    lblProjectFinished.Caption := 'Your article has been created!';
    lblWordCount.Caption := strWordCountPrefix + IntToStr(GetWordCount(StripTags(theProject.Article.Text)));
    lblKeywordDensity.Caption := FloatToStrF(GetKeywordDensity(theProject.Keywords, StripTags(theProject.Article.Text, True)), ffFixed, 10, 2) + '%';
  end
  else begin
    lblProjectFinished.Caption := 'Template file not found! Your article could not be created!';
    lblWordCount.Caption := strWordCountPrefix + '-';
    lblKeywordDensity.Caption := '-';
  end;
end;

Function TfrmMain.FormatKeywords(CommaText: String): String;
var
  Temp        : String;

begin
  Temp := CommaText;
  Temp := StringReplace(Temp, '"', '', [rfReplaceAll]);
  While Pos(',,', Temp) > 0 do
    Temp := StringReplace(Temp, ',,', ',', [rfReplaceAll]);
  While Copy(Temp, Length(Temp), 1) = ',' do
    Delete(Temp, Length(Temp), 1);
  Result := Temp;
end;

procedure TfrmMain.btnProjectListbClick(Sender: TObject);
begin
  SetButtonsDown();
  btnProjectList.Down := True;
  SetActivePanel(pnlProjectList);
  ToggleSteps(False);
  RefreshProjects;
  If frmMain.Visible And ActivePanel.Visible then
    asgProjects.SetFocus;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  RefreshProjects;
end;

procedure TfrmMain.btnEditProjectClick(Sender: TObject);
var
  ID              : String;

begin
  { Almost the same as NewProject...}
  ID := asgProjects.Cells[colID, asgProjects.Row];
  If ID <> '' then begin
    If qryProjects.Locate('id', ID, []) then begin
      ClearProject;
      ClearPanels;
      QueryToProject;
      ProjectToPanels;

      ToggleSteps(True);
      btnStep1.Click;
    end;
  end;
end;

procedure TfrmMain.TBXItem6Click(Sender: TObject);
var
  FileName          : String;
  ShortName         : String;
begin
{  If theProject.Template_Format <> '' then begin }
  If theProject.Template_File <> '' then begin
    FileName := Path + folderTemplate + theProject.Template_File + extTemplate;
    If FileExists(FileName) then begin
      Try
        frmMSHTMLEdit := TfrmMSHTMLEdit.Create(Application);
        frmMSHTMLEdit.thePath := FileName;
        frmMSHTMLEdit.ShowModal;
        begin
          { Did he use the `Save As...` button?  }
          If (frmMSHTMLEdit.thePath <> FileName) And FileExists(frmMSHTMLEdit.thePath) then begin
            { Yes, he did... }
            SetTemplateFiles(cobTemplate, Path + folderTemplate, '*' + extTemplate, 0);
            ShortName := ExtractFileName(frmMSHTMLEdit.thePath);
            ShortName := AnsiLeftStr(ShortName,AnsiPos('.',ShortName)-1);
            cobTemplate.ItemIndex := Max(0, cobTemplate.Items.IndexOf(ShortName));
            cobTemplate.OnChange(Sender);
          end;
        end;
      Finally
        FreeAndNil(frmMSHTMLEdit);
      end;
    end;
  end;
end;

procedure TfrmMain.pnlStep5Enter(Sender: TObject);
begin
  RefreshBodies;
  If Assigned(pnlStep13.OnEnter) then
    pnlStep13.OnEnter(Sender);
end;

procedure TfrmMain.btnDeleteBodyClick(Sender: TObject);
var
  Index           : Integer;

begin
  Index := asgBody.Row;
  If (Index > 0) And (asgBody.Cells[colID, Index] <> '') then begin
    If MessageDlg('Delete the body item `' + asgBody.Cells[colTitle, Index] + '`. Are you sure?', mtCOnfirmation, [mbYes, mbNo], 0) = mrYes then begin
      With qryAddBody do begin
        Close;
        SQL.Clear;
        Parameters.Clear;
        SQL.Add(sqlDeleteBody);
        Parameters.ParamByName('_ID_').Value := StrToIntDef(asgBody.Cells[colID, Index], 0);
        Try
          ExecSQL;
          RefreshBodies;
        Except
          On E: Exception do
            MessageDlg(E.Message, mtError, [mbOK], 0);
        end;
      end;
    end;
  end;
end;

procedure TfrmMain.mnuHTMLExportClick(Sender: TObject);
begin
  If dlgSaveHTML.Execute then
    theProject.Article.SaveToFile(dlgSaveHTML.FileName);
end;

procedure TfrmMain.mnuTXTExportClick(Sender: TObject);
var
  TXTArticle          : TStringList;
  strCPL              : String;
  CPL                 : Integer;

begin
  { Get `chars per line` value... }
  strCPL := InputBox('CPL Value', 'How many characters per line? : ', '60');
  CPL := StrToIntDef(strCPL, -1);
  If CPL > -1 then begin
    If dlgSaveTXT.Execute then begin
      TXTArticle := TStringList.Create;
      TXTArticle.Text := FormatText(StripTags(theProject.Article.Text), CPL);
      TXTArticle.SaveToFile(dlgSaveTXT.FileName);
      FreeAndNil(TXTArticle);
    end;
  end
  else
    MessageDlg('Invalid value supplied: "' + strCPL + '"!', mtError, [mbAbort], 0);
end;

Function TfrmMain.FormatText(Article: String; CPL: Integer): String;
var
  outText         : TStringList;
  Index,
  lastIndex,
  Cnt             : Integer;
  nextLine,
  Line            : String;
  Done            : Boolean;

begin
  outText := TStringList.Create;
  outText.Text := Article;

  Cnt := 0;
  While Cnt < outText.Count do begin
    Line := Trim(outText.Strings[Cnt]);
    If Length(Line) > CPL then begin
      lastIndex := Length(Line);
      Index := Pos(' ', Line);
      While (Index <= CPL + 1) And (Index > 0) do begin
        lastIndex := Index;
        Index := PosEx(' ', Line, lastIndex + 1);
      end;
      { FIX: break the lines with long words... }
      If (Index > CPL + 1) And (lastIndex > Index) then
        lastIndex := Index;

      outText.Strings[Cnt] := Trim(Copy(Line, 1, lastIndex));
      Delete(Line, 1, lastIndex);
      Line := Trim(Line);
      outText.Insert(Cnt + 1, Line);
    end;
    Inc(Cnt);
  end;

  { The lines are fine now... Let's insert some spaces to justify the text... }

  For Cnt := 0 to outText.Count - 1 do begin
    Line := Trim(outText.Strings[Cnt]);
    lastIndex := 0;
    Done := False;
    If Trim(Line) = '' then
      Done := True
    else If Pos(' ', Trim(Line)) = 0 then
      Done := True
    else If Cnt = outText.Count - 1 then
      Done := True
    else begin
      nextLine := outText.Strings[Cnt + 1];
      If (Length(Line) < CPL) And (Trim(nextLine) = '') then
        Done := True
      else begin
        Index := Pos(' ', nextLine);
        If (Length(Line) < CPL) And (Length(Line) + Index < CPL) then
          Done := True 
      end;
    end;

    While (Not Done) And (Length(Line) < CPL) do begin
      Index := PosEx(' ', Line, lastIndex + 1);
      If Index > 0 then
        lastIndex := Index
      else
        lastIndex := Length(Line) + 1;

      If (lastIndex < Length(Line)) {Or (Pos(' ', Line) > 0)} then
        Insert(' ', Line, lastIndex)
      else
        Line := Trim(Line);

      If lastIndex >= Length(Line) then
        lastIndex := 0
      else
        Inc(lastIndex);
    end;

    outText.Strings[Cnt] := Line;
  end;

  Result := outText.Text;
  FreeAndNil(outText);
end;

Function TfrmMain.StripTags(Page: String; NLStrip: Boolean = False; TitleStrip: Boolean = True): String;
var
  idxPos1,
  idxPos2         : Integer;

begin
  Page := StringReplace(Page, '<BR>', #13#10, [rfIgnoreCase, rfReplaceAll]);

  If TitleStrip then begin
    idxPos1 := Pos('<TITLE>', UpperCase(Page));
    If idxPos1 > 0 then begin
      idxPos2 := PosEx('</TITLE>', UpperCase(Page), idxPos1);
      If idxPos2 > idxPos1 then
        Delete(Page, idxPos1, idxPos2 - idxPos1 + Length('</TITLE>'));
    end;
  end;

  idxPos1 := Pos('<', Page);
  While idxPos1 > 0 do begin
    idxPos2 := Pos('>', Page);
    If idxPos2 > idxPos1 then begin
      Delete(Page, idxPos1, idxPos2 - idxPos1 + 1);
      idxPos1 := Pos('<', Page);
    end
    else
      idxPos1 := 0;
  end;

  { Additional stripping... }
  Page := StringReplace(Page, '&nbsp;', ' ', [rfIgnoreCase, rfReplaceAll]);
  If NLStrip then begin
    Page := StringReplace(Page, #13, ' ', [rfIgnoreCase, rfReplaceAll]);
    Page := StringReplace(Page, #10, ' ', [rfIgnoreCase, rfReplaceAll]);
  end;
  While Pos('  ', Page) > 0 do
    Page := StringReplace(Page, '  ', ' ', [rfReplaceAll]);

  Result := Trim(Page);
end;

Function TfrmMain.GetWordCount(Article: String): Integer;
var
  Cnt,
  Words       : Integer;
  Between     : Boolean;

begin
  Words := 0;
  Between := True;
  Cnt := 1;
  While Cnt <= Length(Article) do begin
    If Between then begin
      If Article[Cnt] in ['0'..'9', 'a'..'z', 'A'..'Z'] then begin
        Inc(Words);
        Between := False;
      end;
    end
    else begin
      If Not (Article[Cnt] in ['0'..'9', 'a'..'z', 'A'..'Z']) then
        Between := True;
    end;
    Inc(Cnt);
  end;

  Result := Words;
end;

procedure TfrmMain.btnSpellCheckClick(Sender: TObject);
var
  Nesto           : String;

begin
  { Do a spell check for all items... }
  SpellCheck(theProject.Title);
  SpellCheck(theProject.Product);

  Nesto := theProject.Topics.Text;
  SpellCheck(Nesto);
  theProject.Topics.Text := Nesto;

  SpellCheck(theProject.Y);
  SpellCheck(theProject.Introduction);
  SpellCheck(theProject.Closing);
  SpellCheck(theProject.Byline);

  Nesto := theProject.Keywords.Text;
  SpellCheck(Nesto);
  theProject.Keywords.Text := Nesto;

  SpellCheck(theProject.Description);
  If Assigned(pnlStep13.OnEnter) then
    pnlStep13.OnEnter(Sender);
  MessageDlg('Spelling check completed!', mtInformation, [mbOK], 0);
end;

Function TfrmMain.SpellCheck(var Data: String): Integer;
begin
  Result := 0;
  janSpeller.Spell(Data);
end;

procedure TfrmMain.mnuFTPUploadClick(Sender: TObject);
begin
  Try
    frmFTPParams := TfrmFTPParams.Create(Application);
    frmFTPParams.ShowModal;
  Finally
    FreeAndNil(frmFTPParams);
  end;
end;

Function TfrmMain.GetKeywordDensity(Keyword: String; InfoText: String): Double;
var
  List        : TStringList;

begin
  List := TStringList.Create;
  List.Add(Keyword);
  Result := GetKeywordDensity(List, InfoText);
  FreeAndNil(List);
end;

Function TfrmMain.GetKeywordDensity(Keywords: TStringList; InfoText: String): Double;
var
  Cnt,
  idxPos,
  tmpSPChars,
  tmpOcc,
  tmpChars        : Integer;
  tmpDens         : Double;
  SearchPhrase    : String;

begin
  tmpDens := 0.0;
  tmpChars := Length(InfoText);
  For Cnt := 0 to Keywords.Count - 1 do begin
    SearchPhrase := Keywords.Strings[Cnt];
    tmpSPChars := Length(SearchPhrase);
    tmpOcc := 0;
    If tmpChars >= tmpSPChars then begin
      idxPos := Pos(UpperCase(SearchPhrase), UpperCase(InfoText));
      While idxPos > 0 do begin
        Inc(tmpOcc);
        idxPos := PosEx(UpperCase(SearchPhrase), UpperCase(InfoText), idxPos + Length(SearchPhrase));
      end;

      tmpDens := tmpDens + (tmpOcc * tmpSPChars) / tmpChars;
    end;
  end;
  { Set the value... }
  Result := Round(tmpDens * 100 * 100) / 100;
end;

procedure TfrmMain.btnDelProjectClick(Sender: TObject);
var
  Index           : Integer;

begin
{  Index := asgBody.Row;}
  Index := asgProjects.Row;
  If (Index > 0) And (asgProjects.Cells[colID, Index] <> '') then begin
    If MessageDlg('Delete project `' + asgProjects.Cells[colTitle, Index] + '`. Are you sure?', mtCOnfirmation, [mbYes, mbNo], 0) = mrYes then begin
      With qryAddProject do begin
        Close;
        SQL.Clear;
        Parameters.Clear;
        SQL.Add(sqlDeleteBodyItems);
        Parameters.ParamByName('_ID_').Value := StrToIntDef(asgProjects.Cells[colID, Index], 0);
        Try
          ExecSQL;
        Except
        end;

        Close;
        SQL.Clear;
        Parameters.Clear;
        SQL.Add(sqlDeleteProject);
        Parameters.ParamByName('_ID_').Value := StrToIntDef(asgProjects.Cells[colID, Index], 0);
        Try
          ExecSQL;
          RefreshProjects;
        Except
          On E: Exception do
            MessageDlg(E.Message, mtError, [mbOK], 0);
        end;
      end;
    end;
  end;
end;

procedure TfrmMain.btnNewBodyClick(Sender: TObject);
begin
  { New body item... go to step 6 and get back... }
  CurrentBodyItem := idNoBody;
  edtStep.Text := '';
  memExplain.Text := '';
  btnStep6.Click;
end;

procedure TfrmMain.btnEditBodyClick(Sender: TObject);
var
  Index       : Integer;

begin
  { Edit body... }
  Index := asgBody.Row;
  If (Index > 0) And (asgBody.Cells[colID, Index] <> '') then begin
    CurrentBodyItem := StrToIntDef(asgBody.Cells[colID, Index], idNoBody);
    edtStep.Text := asgBody.Cells[colTitle, Index];
    If qryBody.Locate('id', CurrentBodyItem, []) then
      memExplain.Text := qryBody.FieldByname('body').AsString;
    btnStep6.Click;
  end;
end;

procedure TfrmMain.edtXChange(Sender: TObject);
begin
  If Not ProjectLoading then begin
    theProject.X := edtX.Text;
    theProject.Modified := True;
  end;
end;

procedure TfrmMain.btnClick(Sender: TObject);
var
  Index,
  Cnt           : Integer;
  Keyword       : String;

begin
  { Display the complete keyword density report... }
{}
  Try
    frmKeyDensity := TfrmKeyDensity.Create(Application);
    With frmKeyDensity do begin
      asgKeys.RowCount := 1;
      asgKeys.Cells[0, 0] := 'Keyword';
      asgKeys.Cells[1, 0] := 'Density(%)';
      For Cnt := 0 to theProject.Keywords.Count - 1 do begin
        Keyword := Trim(theProject.Keywords.Strings[Cnt]);
        If Keyword <> '' then begin
          asgKeys.RowCount := asgKeys.RowCount+1;
          asgKeys.FixedRows := 1;

          Index := asgKeys.RowCount - 1;

          asgKeys.Cells[0, Index] := Keyword;
          asgKeys.Cells[1, Index] := FloatToStrF(GetKeywordDensity(Keyword, StripTags(theProject.Article.Text, True)), ffFixed, 10, 2);
        end;
      end;
    end;
    frmKeyDensity.ShowModal;
  Finally
    FreeAndNil(frmKeyDensity);
  end;
end;

procedure TfrmMain.cobTemplateChange(Sender: TObject);
begin
  If Not ProjectLoading then begin
    If theProject.Template_File <> cobTemplate.Text then begin
      theProject.Template_File := cobTemplate.Text;
      theProject.Modified := True;
    end;
  end;
end;

procedure TfrmMain.pnlStep1Enter(Sender: TObject);
begin
  If (theProject.Article.Text <> '') And Assigned(pnlStep13.OnEnter) then
    pnlStep13.OnEnter(Sender);
end;

procedure TfrmMain.pnlStep2Enter(Sender: TObject);
begin
  If (theProject.Article.Text <> '') And Assigned(pnlStep13.OnEnter) then
    pnlStep13.OnEnter(Sender);
end;

procedure TfrmMain.pnlStep6Enter(Sender: TObject);
begin
  If Assigned(pnlStep13.OnEnter) then
    pnlStep13.OnEnter(Sender);
end;

procedure TfrmMain.pnlStep7Enter(Sender: TObject);
begin
  If Assigned(pnlStep13.OnEnter) then
    pnlStep13.OnEnter(Sender);
  { Refresh intros... }
  RefreshSavedTextList(lstSavedIntros, strIntro, PopupMenu1);
  mnuUseSavedIntro.Enabled := lstSavedIntros.Count > 0;
end;

procedure TfrmMain.pnlStep8Enter(Sender: TObject);
begin
  If Assigned(pnlStep13.OnEnter) then
    pnlStep13.OnEnter(Sender);
  { Refresh closings... }
  RefreshSavedTextList(lstSavedClosing, strClosing, PopupMenu2);
  mnuUseSavedClosing.Enabled := lstSavedClosing.Count > 0;
end;

procedure TfrmMain.pnlStep9Enter(Sender: TObject);
begin
  If Assigned(pnlStep13.OnEnter) then
    pnlStep13.OnEnter(Sender);
  { Refresh bylines... }
  RefreshSavedTextList(lstSavedByline, strByline, PopupMenu3);
  mnuUseSavedByLine.Enabled := lstSavedByline.Count > 0;
end;

procedure TfrmMain.pnlStep10Enter(Sender: TObject);
begin
  If Assigned(pnlStep13.OnEnter) then
    pnlStep13.OnEnter(Sender);
end;

procedure TfrmMain.pnlStep11Enter(Sender: TObject);
begin
  If Assigned(pnlStep13.OnEnter) then
    pnlStep13.OnEnter(Sender);
end;

procedure TfrmMain.pnlStep12Enter(Sender: TObject);
begin
  If Assigned(pnlStep13.OnEnter) then
    pnlStep13.OnEnter(Sender);
end;

procedure TfrmMain.pnlProjectListEnter(Sender: TObject);
begin
  SetProjectTitle(strNoProject);
  lblWordCount.Caption := strWordCountPrefix + '-';
end;

procedure TfrmMain.btnPreviewArticleClick(Sender: TObject);
var
  FileName : String;
begin
  { Preview Article... }
  If theProject.Article.Text <> '' then begin
  Try
    FileName := ExtractFilePath(ParamStr(0))+'temp.html';
    theProject.Article.SaveToFile(FileName);
    frmMSHTMLEdit := TfrmMSHTMLEdit.Create(Application);
    frmMSHTMLEdit.thePath := FileName;
    frmMSHTMLEdit.ToolBar1.Visible := False;
    frmMSHTMLEdit.ToolBar2.Visible := False;
    frmMSHTMLEdit.ShowModal;
    DeleteFile(FileName);
    Finally
      FreeAndNil(frmMSHTMLEdit);
    end;
  end;
end;

procedure TfrmMain.btnSaveProjectClick(Sender: TObject);
begin
  { Save Project... }
  If SaveProject then
    btnProjectList.Click;
end;

procedure TfrmMain.mnuSaveBylineClick(Sender: TObject);
var
  tmpTitle            : String;

begin
  { Save... }
  If Trim(memByline.Text) <> '' then begin
    tmpTitle := InputBox('Byline Title', 'Enter byline title: ', '');
    If tmpTitle <> '' then begin
      With qryAddBody do begin
        Close;
        SQL.Clear;
        Parameters.Clear;
        SQL.Add(sqlAddSavedText);
        Parameters.ParamByName('_TYPE_').Value := strByline;
        Parameters.ParamByName('_TITLE_').Value := tmpTitle;
        Parameters.ParamByName('_BODY_').Value := memByline.Text;
        Try
          ExecSQL;
          RefreshSavedTextList(lstSavedByline, strByline, PopupMenu3);
          mnuUseSavedByLine.Enabled := lstSavedByline.Count > 0;
        Except
        end;
      end;
    end;
  end;
end;

Function TfrmMain.RefreshSavedTextList(aTitles: TStrings; aType: String; menu: TPopupMenu): Integer;
var
  item : TMenuItem;
begin
  Result := 0;
  If Assigned(aTitles) then begin
    aTitles.Clear;
    With qryAddBody do begin
      Close;
      SQL.Clear;
      Parameters.Clear;
      SQL.Add(sqlGetSavedTextList);
      Parameters.ParamByName('_TYPE_').Value := aType;
      Try
        Open;
      Except
      end;

      menu.Items.Clear;
      While Not EOF do begin
        aTitles.Append(FieldByname('title').AsString);
        item := TMenuItem.Create(menu);
        item.Caption := FieldByname('title').AsString;
        item.OnClick := N11Click;
        menu.Items.Add(item);
        Next;
      end;

      Close;
    end;

  end;

end;

procedure TfrmMain.mnuSaveClosingClick(Sender: TObject);
var
  tmpTitle            : String;
begin
  { Save... }
  If Trim(edtClosing.Text) <> '' then begin
    tmpTitle := InputBox('Paragraph Title', 'Enter paragraph title: ', '');
    If tmpTitle <> '' then begin
      With qryAddBody do begin
        Close;
        SQL.Clear;
        Parameters.Clear;
        SQL.Add(sqlAddSavedText);
        Parameters.ParamByName('_TYPE_').Value := strClosing;
        Parameters.ParamByName('_TITLE_').Value := tmpTitle;
        Parameters.ParamByName('_BODY_').Value := edtClosing.Text;
        Try
          ExecSQL;
          RefreshSavedTextList(lstSavedClosing, strClosing, PopupMenu2);
          mnuUseSavedClosing.Enabled := lstSavedClosing.Count > 0;
        Except
        end;
      end;
    end;
  end;
end;

procedure TfrmMain.mnuSaveIntroClick(Sender: TObject);
var
  tmpTitle            : String;

begin
  { Save... }
  If Trim(edtIntroduction.Text) <> '' then begin
    tmpTitle := InputBox('Paragraph Title', 'Enter paragraph title: ', '');
    If tmpTitle <> '' then begin
      With qryAddBody do begin
        Close;
        SQL.Clear;
        Parameters.Clear;
        SQL.Add(sqlAddSavedText);
        Parameters.ParamByName('_TYPE_').Value := strIntro;
        Parameters.ParamByName('_TITLE_').Value := tmpTitle;
        Parameters.ParamByName('_BODY_').Value := edtIntroduction.Text;
        Try
          ExecSQL;
          RefreshSavedTextList(lstSavedIntros, strIntro, PopupMenu1);
          mnuUseSavedIntro.Enabled := lstSavedIntros.Count > 0;
        Except
        end;
      end;
    end;
  end;
end;

procedure TfrmMain.asgProjectsDblClick(Sender: TObject);
begin
  If (asgProjects.Row > 0) And btnEditProject.Enabled then
    btnEditProject.Click;
end;

procedure TfrmMain.SetButtonsDown();
begin
  btnStep1.Down := False;
  btnStep1.Font.Style := [];

  btnStep2.Down := False;
  btnStep2.Font.Style := [];

  btnStep3.Down := False;
  btnStep3.Font.Style := [];

  btnStep4.Down := False;
  btnStep4.Font.Style := [];

  btnStep5.Down := False;
  btnStep5.Font.Style := [];

  btnStep6.Down := False;
  btnStep6.Font.Style := [];

  btnStep7.Down := False;
  btnStep7.Font.Style := [];

  btnStep8.Down := False;
  btnStep8.Font.Style := [];

  btnStep9.Down := False;
  btnStep9.Font.Style := [];

  btnStep10.Down := False;
  btnStep10.Font.Style := [];

  btnStep11.Down := False;
  btnStep11.Font.Style := [];

  btnStep12.Down := False;
  btnStep12.Font.Style := [];

  btnStep13.Down := False;
  btnStep13.Font.Style := [];
end;

procedure TfrmMain.N11Click(Sender: TObject);
var
  tmpTitle   : String;
  tmpType    : String;
  tip        : Integer;
begin
  tip := 0;
  if ((Sender as TMenuItem).GetParentComponent.GetNamePath = 'PopupMenu1') then begin
      tmpType := strIntro;
      tip := 1;
      end;
  if ((Sender as TMenuItem).GetParentComponent.GetNamePath = 'PopupMenu2') then begin
      tmpType := strClosing;
      tip := 2;
      end;
  if ((Sender as TMenuItem).GetParentComponent.GetNamePath = 'PopupMenu3') then begin
      tmpType := strByline;
      tip := 3;
      end;
  tmpTitle := (Sender as TMenuItem).Caption;
  tmpTitle := AnsiReplaceStr(tmpTitle,'&','');
  If tmpTitle <> '' then begin
    With qryAddBody do begin
      Close;
      SQL.Clear;
      Parameters.Clear;
      SQL.Add(sqlGetSavedText);
      Parameters.ParamByName('_TYPE_').Value := tmpType;
      Parameters.ParamByName('_TITLE_').Value := tmpTitle;
      Try
        Open;
      Except
      end;

    If Not EOF then begin
      if (tip = 1) then
         edtIntroduction.Text := FieldByName('body').AsString;
      if (tip = 2) then
         edtClosing.Text := FieldByName('body').AsString;
      if (tip = 3) then
         memByline.Text := FieldByName('body').AsString;
      end;
      Close;
      end;
   end;
end;

end.
