unit mshtml_edit;

{ LOG FROM SOURCESAFE --
   $Log:: /Delphi/MSHTML Editor/mshtml_edit.pas                               $
 * 
 * 11    10/02/01 8:23a Danr
 * -Added indent paragraph code
 * -Added preformatted code (for charts)
 * -Added remove formatting code
 * -Make sure file is not editable when saved
 * -Uses SKS and DISCO style sheets
 * -Select paragraph utility routine
 * -Rewrote the heading code to work as a toggle (works along with the style
 * sheet)
 * 
 * 10    9/20/01 9:19a Danr
 * Made the spell checker and thesaurus modal.
 * 
 * 9     9/20/01 9:11a Danr
 * Thesaurus completed.
 * 
 * 8     9/17/01 4:54p Danr
 * Another "back-up" check-in.
 * 
 * 6     9/10/01 3:14p Danr
 * Added Thesaurs inteface (no form yet).
 * 
 * Added code to indicate we have an active selection (via a public variable).
 *
 * 5     9/06/01 2:35p Danr
 * Added the ValidWord procedure.
 *
   $NoKeywords: $
}

{

 >- MSHTML_EDIT
    |
    +-- SPELL <- - (Ole) - -> Word 97 or better
    |   |
    |   +-- OPTIONS
    |
    +-- FIND
    |
    +-- REPLACE
    |
    +-- THESAURUS <- - (Ole) - -> Word 97 or better

}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, MSHTML_TLB, ExtCtrls, ToolWin, ComCtrls, ActnList, Variants,
  Menus, ImgList, StdCtrls, ActiveX, SHDocVw, ComObj, OleServer, Word97;

type
  TfrmMSHTMLEdit = class(TForm)
    sbarEdit: TStatusBar;
    ToolBar1: TToolBar;
    ToolBar2: TToolBar;
    Panel1: TPanel;
    wbEdit: TWebBrowser;
    actMain: TActionList;
    actOpen: TAction;
    actSave: TAction;
    actEditMode: TAction;
    actViewMode: TAction;
    tbSep1: TToolButton;
    tbEdit: TToolButton;
    tbView: TToolButton;
    actExit: TAction;
    tbExit: TToolButton;
    ImageList1: TImageList;
    tbSep2: TToolButton;
    actSaveAs: TAction;
    tbOpen: TToolButton;
    tbSave: TToolButton;
    tbSaveAs: TToolButton;
    actViewSource: TAction;
    tbViewSource: TToolButton;
    edtHTML: TRichEdit;
    tbSep3: TToolButton;
    tbBold: TToolButton;
    tbItalic: TToolButton;
    actBold: TAction;
    actItalic: TAction;
    actUnderline: TAction;
    actH1: TAction;
    actLeftJustify: TAction;
    actCenterJustify: TAction;
    actRightJustify: TAction;
    tbSep7: TToolButton;
    tbCut: TToolButton;
    tbCopy: TToolButton;
    tbPaste: TToolButton;
    actCut: TAction;
    actCopy: TAction;
    actPaste: TAction;
    actH2: TAction;
    actH3: TAction;
    actH5: TAction;
    actBlockCommands: TAction;
    tbSep5: TToolButton;
    tbPrint: TToolButton;
    actPrint: TAction;
    actViewText: TAction;
    tbViewText: TToolButton;
    actUnDo: TAction;
    tbSep6: TToolButton;
    tbUnDo: TToolButton;
    tbReDo: TToolButton;
    actReDo: TAction;
    actSearch: TAction;
    tbSep9: TToolButton;
    tbSuper: TToolButton;
    tbSub: TToolButton;
    actSub: TAction;
    actSuper: TAction;
    actReplace: TAction;
    tbIndent: TToolButton;
    tbFormatted: TToolButton;
    tbNormal: TToolButton;
    actIndent: TAction;
    actPre: TAction;
    actNormal: TAction;
    actH4: TAction;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    procedure actExitExecute(Sender: TObject);
    procedure actEditModeExecute(Sender: TObject);
    procedure actViewModeExecute(Sender: TObject);
    procedure actViewSourceExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure actOpenExecute(Sender: TObject);
    procedure actSaveExecute(Sender: TObject);
    procedure actSaveAsExecute(Sender: TObject);
    procedure ManageAct(iActIs: integer);
    procedure actBoldExecute(Sender: TObject);
    procedure actItalicExecute(Sender: TObject);
    procedure actUnderlineExecute(Sender: TObject);
    procedure actH1Execute(Sender: TObject);
    procedure actLeftJustifyExecute(Sender: TObject);
    procedure actCenterJustifyExecute(Sender: TObject);
    procedure actRightJustifyExecute(Sender: TObject);
    procedure actH2Execute(Sender: TObject);
    procedure actH3Execute(Sender: TObject);
    procedure actH5Execute(Sender: TObject);
    procedure actCutExecute(Sender: TObject);
    procedure actCopyExecute(Sender: TObject);
    procedure actPasteExecute(Sender: TObject);
    procedure wbEditCommandStateChange(Sender: TObject; Command: Integer;
      Enable: WordBool);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure actBlockCommandsExecute(Sender: TObject);
    procedure OleError(Hr: HResult);
    procedure SelectParagraph;
    procedure actPrintExecute(Sender: TObject);
    procedure actViewTextExecute(Sender: TObject);
    procedure actUnDoExecute(Sender: TObject);
    procedure actReDoExecute(Sender: TObject);
    procedure actSearchExecute(Sender: TObject);
    procedure actSubExecute(Sender: TObject);
    procedure actSuperExecute(Sender: TObject);
    procedure actReplaceExecute(Sender: TObject);
    procedure CheckDialog;
    procedure actIndentExecute(Sender: TObject);
    procedure actPreExecute(Sender: TObject);
    procedure actNormalExecute(Sender: TObject);
    procedure actH4Execute(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }

  public
    { Public declarations }
    thePath             : OLEVariant; { String; }
    ReadOnly            : Boolean;

    FDocument:  IHTMLDocument2;     //MSHTML HTML Document 2 interface
    FCommand:   IOleCommandTarget;  //MSHTML IOLECommandTarget interface
    FBody:      IHTMLBodyElement;   //MSHTML HTML Body element interface
    FRange:     IHTMLTxtRange;      //MSHTML HTML Text range interface
    FRangeToo:  IHTMLTxtRange;      //MSHTML HTML Text range interface
                                    //(created as needed)
    FSelect:    IHTMLSelectionObject;
    FMarkUp:    IMarkupServices;    //MSHTML IMarkupServices interface
    FMarkCont:  IMarkupContainer;   //MSHTML IMarkupContainer interface
    FMarkPtr1,
    FMarkPtr2:  IMarkupPointer;     //MSHTML IMarkupPointer interface

    FsFilename: string;             //Current filename
    FbEmpty:    boolean;            //True if no file is loaded
    FbEdit:     boolean;            //True if we are in edit mode
    FbDirty:    boolean;            //True if things have changed
    FsHTMLImage: string;            //Source image of the current page (detect changes)
    FbTagToggle: boolean;
    FbHaveSelect: boolean;          //Indicates there is an active selection
                                    //for spell check, find and find/replace.
    procedure OpenDoc(FsFilename: String);
  end;

const
  c_True         = 1; {Used as OLE argument for true}
  c_False        = 0; {Used as OLE argument for false}
  SNAPPath       = '';
  folderTemplate        = 'templates\';

var
  frmMSHTMLEdit: TfrmMSHTMLEdit;

implementation
  uses IEConst, Find, Replace;


const
  {Define the various actions so we can control them from a central
   procedure called ManageAct(iAct).}
  iShow          = -1;
  iOpen          = 0;
  iSave          = 1;
  iSaveAs        = 2;
  iExit          = 3;
  iEditMode      = 4;
  iViewMode      = 5;
  iViewSource    = 6;
  iBold          = 7;
  iItalic        = 8;
  iUnderline     = 9;
  iH1            = 10;
  iH2            = 11;
  iH3            = 12;
  iH5            = 13;
  iLeftJustify   = 14;
  iCenterJustify = 15;
  iRightJustify  = 16;
  iCut           = 17;
  iCopy          = 18;
  iPaste         = 19;
  iViewTags      = 20; {Unused...}
  iPrint         = 21;
  iViewText      = 22;
  iUnDo          = 23;
  iReDo          = 24;
  iFind          = 25;
  iSub           = 26;
  iSuper         = 27;
  iSpell         = 28;
  iReplace       = 29;
  iTheas         = 30;
  iIndent        = 31;
  iPre           = 32; {Formatted <pre>...</pre> or "Chart"}
  iNormal        = 33; {Remove block formats 'normal'}
  iH4            = 34;

  CRLF = #13 + #10;
  CR   = #13;
  LF   = #10;

  {For the time being...}
  iSTD = 0;
  iRES = 1;
  iDIS = 2;
  iREN = 3;
  iGOV = 4;
  iProduct = 0;

  {Some GUID's to interact with the MSHTML IOleCommandTarget interface}
  GUID_IMSHTMLDocument: TGUID = '{626FC520-A41E-11cf-A731-00A0C9082637}';

{$R *.DFM}


{Open and load an HTML document...
 Also create the MSHTML Document 2 interface}
procedure TfrmMSHTMLEdit.actOpenExecute(Sender: TObject);
var
  dlgOpen: TOpenDialog;
begin
  {Determine what document to load...}
  if (not FbEmpty) then
  begin
    CheckDialog;
    if (FbEdit) then
      actViewModeExecute(self);
    FMarkPtr2     := Nil;
    FMarkPtr1     := Nil;
    FMarkCont     := Nil;
    FMarkup       := Nil;
    FRange        := Nil;
    FBody         := Nil;
    FCommand      := Nil;
    FDocument     := Nil;
    FbEmpty   := True;
  end;
  sbarEdit.Panels[0].Text := 'Opening...';
  dlgOpen := TOpenDialog.Create(self);
  try
    dlgOpen.DefaultExt := 'html';
    dlgOpen.InitialDir := folderTemplate;
    dlgOpen.Filter := 'HTML files (*.html)|*.HTML' +
                      '|HTML files (*.htm)|*.HTM' +
                      '|All files (*.*)|*.*';
    dlgOpen.Options := [ofHideReadOnly, ofPathMustExist, ofFileMustExist,
                        ofEnableSizing];
    dlgOpen.Title := 'Open HTML file';
    dlgOpen.Execute;
    FsFilename := string(dlgOpen.FileName);
  finally
    dlgOpen.Free;
  end;

// opening file FsFilename
  OpenDoc(FsFilename);

end;

procedure TfrmMSHTMLEdit.OpenDoc(FsFilename: String);
begin
  sbarEdit.Panels[0].Text := 'Loading...';

  {Load the HTML document and wait for it to be ready}
  wbEdit.Navigate(FsFilename);
  while (wbEdit.ReadyState <> ReadyState_Complete) do
    Application.ProcessMessages;

  {Create/invoke the MSHTML document interface}
  FDocument := wbEdit.Document as IHTMLDocument2;

  {Create/invoke the MSHTML IOleCommand interface}
  FCommand := FDocument as IOleCommandTarget;

  {Create/Invoke the MSHTML BodyElement and TextRange interfaces}
  FBody := FDocument.body as IHTMLBodyElement;
  FRange := FBody.createTextRange;

  {Create/invoke the MSHTML IMarkupServices interfaces}
  FMarkup := FDocument as IMarkupServices;
  FMarkup.CreateMarkupContainer(FMarkCont);
  FMarkCont.OwningDoc(FDocument);
  FMarkup.CreateMarkupPointer(FMarkPtr1);
  FMarkup.CreateMarkupPointer(FMarkPtr2);
  FMarkPtr1.MoveToContainer(FMarkCont, c_True);
  FMarkPtr2.MoveToContainer(FMarkCont, c_False);

  FbEmpty := False;
  actViewModeExecute(Self);
  frmMSHTMLEdit.Caption := 'HTML Edit - ' + FsFilename;

  {Use to detect when the document changes}
  FsHTMLImage := FDocument.body.innerHTML;
  FbDirty := False;

  FbTagToggle := False;
  sbarEdit.Panels[0].Text := 'Browse mode';
  ManageAct(iOpen);
end;

{Exit processing}
procedure TfrmMSHTMLEdit.actExitExecute(Sender: TObject);
begin
  if (not FbEmpty) then
  begin
    FMarkPtr2     := Nil;
    FMarkPtr1     := Nil;
    FMarkCont     := Nil;
    FMarkup       := Nil;
    FRange        := Nil;
    FBody         := Nil;
    FCommand      := Nil;
    FDocument     := Nil;
  end;
  FbEmpty := True;
  Close;
end;


{Just started up and no document is loaded}
procedure TfrmMSHTMLEdit.FormShow(Sender: TObject);
begin
  FbEmpty       := True;
  FbEdit        := False;
  FbDirty       := False;
  FbHaveSelect  := False;
  while (wbEdit.ReadyState <> ReadyState_Complete) do
    Application.ProcessMessages;
  wbEdit.BringToFront;
  sbarEdit.Panels[0].Text := 'Empty';
  ManageAct(iShow);
  If thePath <> '' then begin
    Try
      OpenDoc(thePath);
    Except
    end;
  end;
end;


{Put the document in edit mode}
procedure TfrmMSHTMLEdit.actEditModeExecute(Sender: TObject);
begin
  if (not FbEmpty) then
  begin
    CheckDialog;
    FDocument.body.setAttribute('contentEditable', 'true', 0);
    sbarEdit.Panels[0].Text := 'Edit mode';
    wbEdit.BringToFront;
    FbEdit := True;
    FsHTMLImage := FDocument.body.innerHTML;
    ManageAct(iEditMode);
  end;
end;


{Put the document in view or browse mode}
procedure TfrmMSHTMLEdit.actViewModeExecute(Sender: TObject);
begin
  if (not FbEmpty) then
  begin
    CheckDialog;
    FDocument.body.setAttribute('contentEditable', 'false', 0);
    sbarEdit.Panels[0].Text := 'Browse mode';
    wbEdit.BringToFront;
    FbEdit := False;
    ManageAct(iViewMode);
  end;
end;


{Pull the edit window forward and show the HTML source}
procedure TfrmMSHTMLEdit.actViewSourceExecute(Sender: TObject);
begin
  if (not FbEmpty) then
  begin
    CheckDialog;
    FDocument.body.setAttribute('contentEditable', 'false', 0);
    FbEdit := False;
    edtHTML.Text := FDocument.body.outerHTML;
    sbarEdit.Panels[0].Text := 'View source';
    edtHTML.BringToFront;
    ManageAct(iViewSource);
  end;
end;


{Pull the edit window forward and show only the text}
procedure TfrmMSHTMLEdit.actViewTextExecute(Sender: TObject);
begin
  if (not FbEmpty) then
  begin
    CheckDialog;
    FDocument.body.setAttribute('contentEditable', 'false', 0);
    FbEdit := False;
    edtHTML.Text := FDocument.body.Get_outerText;
    sbarEdit.Panels[0].Text := 'View text';
    edtHTML.BringToFront;
    ManageAct(iViewText);
  end;
end;


{Save the curent HTML Document}
procedure TfrmMSHTMLEdit.actSaveExecute(Sender: TObject);
var
  sHTML,
  sStat:
    string;
  fsOut:
    TFileStream;
begin
  CheckDialog;
  if FbEdit then
  begin
    FDocument.body.setAttribute('contentEditable', 'false', 0);
    FbEdit := False;
    wbEdit.BringToFront;
  end;
  sbarEdit.Panels[0].Text := 'Browse mode';
  sStat := sbarEdit.Panels[0].Text;
  sbarEdit.Panels[0].Text := 'Saving...';
  wbEdit.BringToFront;
  if iProduct <> iDIS then
    sHTML := '<html><head>' + CRLF +
             '<link rel="stylesheet" href="sks.css" ' +
             'media="screen" type="text/css">' + CRLF +
             '</head>' + CRLF +
             FDocument.body.outerHTML + CRLF + '</html>'
  else
    sHTML := '<html><head>' + CRLF +
             '<link rel="stylesheet" href="disco.css" ' +
             'media="screen" type="text/css">' + CRLF +
             '</head>' + CRLF +
             FDocument.body.outerHTML + CRLF + '</html>';
  fsOut := TFileStream.Create(FsFilename, fmOpenWrite or fmShareExclusive);
  try
    fsOut.Write(pchar(sHTML)^, length(sHTML));
  finally
    fsOut.Free;
  end;
  FbDirty := False;
  sbarEdit.Panels[0].Text := sStat;
  ManageAct(iSave);
end;


{Save the current HTML document as...}
procedure TfrmMSHTMLEdit.actSaveAsExecute(Sender: TObject);
var
  sStat,
  sFil,
  sHTML:
    string;
  fsOut:
    TFileStream;
  dlgSaveAs:
    TSaveDialog;
begin
  CheckDialog;
  begin
    FDocument.body.setAttribute('contentEditable', 'false', 0);
    FbEdit := False;
    wbEdit.BringToFront;
  end;
  sbarEdit.Panels[0].Text := 'Browse mode';
  sStat := sbarEdit.Panels[0].Text;
  sbarEdit.Panels[0].Text := 'Saving as...';
  sFil := FsFilename;
  dlgSaveAs := TSaveDialog.Create(Self);
  try
    dlgSaveAs.DefaultExt := 'html';
    dlgSaveAs.InitialDir := folderTemplate;
    dlgSaveAs.Filter := 'HTML files (*.html)|*.HTML' +
                        '|HTML files (*.htm)|*.HTM' +
                        '|All files (*.*)|*.*';
    dlgSaveAs.Options := [ofHideReadOnly, ofCreatePrompt, ofOverwritePrompt,
                          ofEnableSizing];
    dlgSaveAs.Title := 'SaveAs HTML file';
    dlgSaveAs.Execute;
    FsFilename := dlgSaveAs.FileName;
  finally
    dlgSaveAs.Free;
  end;
  if Length(FsFilename) > 0 then
  begin
    wbEdit.BringToFront;
  if iProduct <> iDIS then
    sHTML := '<html><head>' + CRLF +
             '<link rel="stylesheet" href="sks.css" ' +
             'media="screen" type="text/css">' + CRLF +
             '</head>' + CRLF +
             FDocument.body.outerHTML + CRLF + '</html>'
  else
    sHTML := '<html><head>' + CRLF +
             '<link rel="stylesheet" href="disco.css" ' +
             'media="screen" type="text/css">' + CRLF +
             '</head>' + CRLF +
             FDocument.body.outerHTML + CRLF + '</html>';
    fsOut := TFileStream.Create(FsFilename, fmCreate or fmShareExclusive);
    try
      fsOut.Write(pchar(sHTML)^, length(sHTML));
    finally
      fsOut.Free;
    end;
    frmMSHTMLEdit.Caption := 'HTML Edit - ' + FsFilename;
    FbDirty := False;
    thePath := FsFilename;
  end
  else
  begin
    ShowMessage('Cancel detected, file not saved!');
    FsFilename := sFil;
  end;
  sbarEdit.Panels[0].Text := sStat;
  ManageAct(iSaveAs);
end;


{Manage the toolbar, and menu via the action list...}
{... A lot of redundant code here... have to clean it up eventually...}
procedure TfrmMSHTMLEdit.ManageAct(iActIs: integer);
var
  sHTMLImage: string;
begin

  {Set the edit related commands (Some actions override these)}
  if (FbEdit) Then
  begin
    actBold.Enabled          := True;
    actItalic.Enabled        := True;
    actUnderline.Enabled     := True;
    actLeftJustify.Enabled   := True;
    actCenterJustify.Enabled := True;
    actRightJustify.Enabled  := True;
    actH1.Enabled            := True;
    actH2.Enabled            := True;
    actH3.Enabled            := True;
    actH4.Enabled            := True;
    actH5.Enabled            := True;
    actCut.Enabled           := FDocument.queryCommandEnabled('Cut');
    actCopy.Enabled          := FDocument.queryCommandEnabled('Copy');
    actPaste.Enabled         := FDocument.queryCommandEnabled('Paste');
    actUnDo.Enabled          := FDocument.queryCommandEnabled('Undo');
    actReDo.Enabled          := FDocument.queryCommandEnabled('Redo');
    actSub.Enabled           := True;
    actSuper.Enabled         := True;
    actSearch.Enabled        := True;
    actReplace.Enabled       := True;
    actIndent.Enabled        := True;
    actPre.Enabled           := True;
    actNormal.Enabled        := True;
  end
  else
  begin
    actBold.Enabled          := False;
    actItalic.Enabled        := False;
    actUnderline.Enabled     := False;
    actLeftJustify.Enabled   := False;
    actCenterJustify.Enabled := False;
    actRightJustify.Enabled  := False;
    actH1.Enabled            := False;
    actH2.Enabled            := False;
    actH3.Enabled            := False;
    actH4.Enabled            := False;
    actH5.Enabled            := False;
    actCut.Enabled           := False;
    actCopy.Enabled          := False;
    actPaste.Enabled         := False;
    actUnDo.Enabled          := False;
    actReDo.Enabled          := False;
    actSub.Enabled           := False;
    actSuper.Enabled         := False;
    actSearch.Enabled        := False;
    actReplace.Enabled       := False;
    actIndent.Enabled        := False;
    actPre.Enabled           := False;
    actNormal.Enabled        := False;
  end;

  case iActIs of

    iOpen:
    begin
      actOpen.Enabled          := True;
      actSave.Enabled          := True;
      actSaveAs.Enabled        := True;
      actViewMode.Enabled      := False; {Default mode}
      actEditMode.Enabled      := True;
      actViewSource.Enabled    := True;
      actViewText.Enabled      := True;
      actPrint.Enabled         := True;
    end;

    iShow:
    begin
      actOpen.Enabled          := True;
      actSave.Enabled          := False;
      actSaveAs.Enabled        := False;
      actViewMode.Enabled      := False;
      actEditMode.Enabled      := False;
      actViewSource.Enabled    := False;
      actViewText.Enabled      := False;
      actBold.Enabled          := False;
      actItalic.Enabled        := False;
      actUnderline.Enabled     := False;
      actLeftJustify.Enabled   := False;
      actCenterJustify.Enabled := False;
      actRightJustify.Enabled  := False;
      actH1.Enabled            := False;
      actH2.Enabled            := False;
      actH3.Enabled            := False;
      actH4.Enabled            := False;
      actH5.Enabled            := False;
      actCut.Enabled           := False;
      actCopy.Enabled          := False;
      actPaste.Enabled         := False;
      actPrint.Enabled         := False;
      actUnDo.Enabled          := False;
      actReDo.Enabled          := False;
      actSub.Enabled           := False;
      actSuper.Enabled         := False;
      actSearch.Enabled        := False;
      actReplace.Enabled       := False;
      actIndent.Enabled        := False;
      actPre.Enabled           := False;
      actNormal.Enabled        := False;
    end;

    iEditMode:
    begin
      actViewMode.Enabled      := True;
      actEditMode.Enabled      := False;
      actViewSource.Enabled    := True;
      actViewText.Enabled      := True;
      actPrint.Enabled         := True;
    end;

    iViewMode:
    begin
      actViewMode.Enabled      := False;
      actEditMode.Enabled      := True;
      actViewSource.Enabled    := True;
      actViewText.Enabled      := True;
      actPrint.Enabled         := True;
      if (assigned(frmFind)) then
        if (frmFind.Showing) then
          frmFind.Close;
    end;

    iViewSource:
    begin
      actViewMode.Enabled      := True;
      actEditMode.Enabled      := True;
      actViewSource.Enabled    := False;
      actViewText.Enabled      := True;
      actPrint.Enabled         := False;
      if (assigned(frmFind)) then
        if (frmFind.Showing) then
          frmFind.Close;
    end;

    iViewText:
    begin
      actViewMode.Enabled      := True;
      actEditMode.Enabled      := True;
      actViewSource.Enabled    := True;
      actViewText.Enabled      := False;
      actPrint.Enabled         := False;
      if (assigned(frmFind)) then
        if (frmFind.Showing) then
          frmFind.Close;
    end;

    iSave, iSaveAs:
    begin
      if (FbEdit) then
      begin
        actViewMode.Enabled      := True;
        actEditMode.Enabled      := False;
        actViewSource.Enabled    := True;
        actViewText.Enabled      := True;
        actPrint.Enabled         := True;
      end
      else
      begin
        actViewMode.Enabled      := False;
        actEditMode.Enabled      := True;
        actViewSource.Enabled    := True;
        actViewText.Enabled      := True;
        actPrint.Enabled         := True;
      end;
    end;
  end;

  {This code looks for changes in the HTML and sets the dirty flag as needed}
  if (not FbEmpty) then
  begin
    sHTMLImage := FDocument.body.innerHTML;
    if (sHTMLImage <> FsHTMLImage) then
      FbDirty := True;
    FsHTMLImage := sHTMLImage;
    if (FbDirty) then
      sbarEdit.Panels[1].Text := 'Changed'
    else
      sbarEdit.Panels[1].Text := '';
    sbarEdit.Panels[2].Text := FsFilename;
    if (FbEdit) then
      wbEdit.SetFocus;
  end;
end;


{Update the Cut, Copy and Paste actions if we are in edit mode...
 manage the Undo/Redo button actions too.}
procedure TfrmMSHTMLEdit.wbEditCommandStateChange(Sender: TObject;
  Command: Integer; Enable: WordBool);
var
  sHTMLImage: string;
begin
  if (not FbEmpty) then
  begin
    if (FbEdit) then
    begin
      actCut.Enabled   := FDocument.queryCommandEnabled('Cut');
      actCopy.Enabled  := FDocument.queryCommandEnabled('Copy');
      actPaste.Enabled := FDocument.queryCommandEnabled('Paste');
      actUnDo.Enabled  := FDocument.queryCommandEnabled('Undo');
      actReDo.Enabled  := FDocument.queryCommandEnabled('Redo');
      actH1.Enabled    := True;
      actH2.Enabled    := True;
      actH3.Enabled    := True;
      actH4.Enabled    := True;
      actH5.Enabled    := True;
    end
    else
    begin
      actCut.Enabled   := False;
      actCopy.Enabled  := False;
      actPaste.Enabled := False;
      actUnDo.Enabled  := False;
      actReDo.Enabled  := False;
      actH1.Enabled    := False;
      actH2.Enabled    := False;
      actH3.Enabled    := False;
      actH4.Enabled    := False;
      actH5.Enabled    := False;
    end;

    {This code looks for changes in the HTML and sets the dirty flag as needed}
    sHTMLImage := FDocument.body.innerHTML;
    if (sHTMLImage <> FsHTMLImage) then
      FbDirty := True;
    FsHTMLImage := sHTMLImage;
    if (FbDirty) then
      sbarEdit.Panels[1].Text := 'Changed'
    else
      sbarEdit.Panels[1].Text := '';
    sbarEdit.Panels[2].Text := FsFilename;
  end;
end;


{Close processing}
procedure TfrmMSHTMLEdit.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;


{Free up MSHTML and ourselves}
procedure TfrmMSHTMLEdit.FormDestroy(Sender: TObject);
begin
  if (not FbEmpty) then
  begin
    FMarkPtr2     := Nil;
    FMarkPtr1     := Nil;
    FMarkCont     := Nil;
    FMarkup       := Nil;
    FRange        := Nil;
    FBody         := Nil;
    FCommand      := Nil;
    FDocument     := Nil;
    frmMSHTMLEdit := nil;
  end;
end;


{This is really a debugging tool}
procedure TfrmMSHTMLEdit.actBlockCommandsExecute(Sender: TObject);
var
  sCommands:  string;
  Hr:         Hresult;
  varRange:   OleVariant;
  I:          Integer;
  S:          String;
  Po:         POleStr;
  Ps:         PSafeArray;
begin
  sCommands := 'Block Format Commands' + CRLF + CRLF;

  TVariantArg(VarRange).VT := VT_ARRAY;
  TVariantArg(VarRange).ppArray := nil;

  Hr := FCommand.Exec(@CGID_MSHTML, IDM_GETBLOCKFMTS,
                  MSOCMDEXECOPT_DONTPROMPTUSER, EmptyParam, VarRange);
  if Hr = S_OK then
  begin
    Ps := TVariantArg(VarRange).pArray;
    try
      for I := VarArrayLowBound(VarRange, 1) to VarArrayHighBound(VarRange, 1) do
      begin
        SafeArrayGetElement(Ps, I, Po);
        S := OleStrToString(Po);
        sCommands := sCommands + S + CRLF;
      end;
    finally
      SafeArrayDestroy(Ps);
    end;
  end
  else
    sCommands := 'GetBlockFmts error';
  ShowMessage(sCommands);
end;


procedure TfrmMSHTMLEdit.OleError(Hr: HResult);
var
  sError: string;
begin
  sError := 'Unknown error: ';
  case Hr of
    OLECMDERR_E_UNKNOWNGROUP:
      sError := 'Unknown command group. ';
    OLECMDERR_E_NOTSUPPORTED:
      sError := 'Command not supported. ';
    OLECMDERR_E_DISABLED:
      sError := 'Command is disabled. ';
    OLECMDERR_E_NOHELP:
      sError := 'Help requested but no help available. ';
    OLECMDERR_E_CANCELED:
      sError := 'User canceled the command. ';
    E_FAIL:
      sError := 'Unspecified error (E_FAIL). ';
    E_UNEXPECTED:
      sError := 'Unexpected error (E_UNEXPECTED). ';
    CO_E_NOTINITIALIZED:
      sError := 'CoInitialize has not been called. ';
  end;
  if Hr <> S_OK then
  begin
    sError := sError + IntToHex(Hr, 8);
    ShowMessage(sError);
  end;
end;


{Select paragraph}
procedure TfrmMSHTMLEdit.SelectParagraph;
var
  sText:  string;
  bGot:   boolean;
  iLast:  integer;
begin
  {
  //Initialize FSelect, verify and set FRange before calling!

  FSelect := FDocument.selection;
  if ((SameText(FSelect.type_, 'Text'))  or
      (SameText(FSelect.type_, 'None'))) then
  begin
    FRange := FSelect.CreateRange as IHTMLTxtRange;
    SelectParagraph;
  }

  //FRange.collapse(True);

  {Move to the end of the paragraph}
  bGot := False;
  sText := ' ';
  while (not bGot) do
  begin
    iLast := length(sText)-1;
    if ((sText[iLast] = CR)  or
        (sText[iLast] = LF)) then
    begin
      FRange.moveEnd('character', -2);
      bgot := True;
    end
    else
    begin
      FRange.moveEnd('character',1);
      FRange.Select;
      sText := FRange.Get_text;
      if (length(sText) < 1) then
      begin
        FRange.moveEnd('character',-1);
        FRange.Select;
        sText := ' ';
        bGot := True;
      end;
    end;
  end;

  {Move to the start of the paragraph...}
  bGot  := False;
  while (not bGot) do
  begin
    if ((sText[1] = CR)  or
        (sText[1] = LF)) then
    begin
      FRange.moveStart('character', 1);
      bgot := True;
    end
    else
    begin
      FRange.moveStart('character',-1);
      FRange.Select;
      sText := FRange.Get_text;
      if (length(sText) < 1) then
      begin
        FRange.moveStart('character',1);
        FRange.Select;
        sText := ' ';
        bGot := True;
      end;
    end;
  end;

  {Select the text in the paragraph}
  FRange.select;

end;

{Toggle BOLD}
procedure TfrmMSHTMLEdit.actBoldExecute(Sender: TObject);
begin
  FDocument.execCommand('Bold', False, 0);
  ManageAct(iBold);
end;


{Toggle ITALICS}
procedure TfrmMSHTMLEdit.actItalicExecute(Sender: TObject);
begin
  FDocument.execCommand('Italic', False, 0);
  ManageAct(iItalic);
end;


{Toggle underline}
procedure TfrmMSHTMLEdit.actUnderlineExecute(Sender: TObject);
begin
  FDocument.execCommand('Underline', False, 0);
  ManageAct(iUnderline);
end;


{LEFT Justify}
procedure TfrmMSHTMLEdit.actLeftJustifyExecute(Sender: TObject);
begin
  if (not FDocument.queryCommandState('JustifyLeft')) then
    FDocument.execCommand('JustifyLeft', False, 0);
  ManageAct(iLeftJustify);
end;


{CENTER Justify (or toggle to Left Justify)}
procedure TfrmMSHTMLEdit.actCenterJustifyExecute(Sender: TObject);
begin
  if (not FDocument.queryCommandState('JustifyCenter')) then
    FDocument.execCommand('JustifyCenter', False, 0)
  else
    FDocument.execCommand('JustifyLeft', False, 0);
  ManageAct(iCenterJustify);
end;


{RIGHT Justify (or toggle to Left Justify)}
procedure TfrmMSHTMLEdit.actRightJustifyExecute(Sender: TObject);
begin
  if (not FDocument.queryCommandState('JustifyRight')) then
    FDocument.execCommand('JustifyRight', False, 0)
  else
    FDocument.execCommand('JustifyLeft', False, 0);
  ManageAct(iRightJustify);
end;

(*
{H1}
procedure TfrmMSHTMLEdit.actH1Execute(Sender: TObject);
var
  vFmtIs: OleVariant;
begin
  OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT,
                     MSOCMDEXECOPT_DONTPROMPTUSER, Variants.Null, vFmtIs));
  if vFmtIs <> 'Heading 1' then
    OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT,
                       MSOCMDEXECOPT_DONTPROMPTUSER, 'Heading 1', EmptyParam))
  else
    OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT,
                       MSOCMDEXECOPT_DONTPROMPTUSER, 'Normal', EmptyParam));
  ManageAct(iH1);
end;

{H2}
procedure TfrmMSHTMLEdit.actH2Execute(Sender: TObject);
var
  vFmtIs: OleVariant;
begin
{  OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT,
                     MSOCMDEXECOPT_DONTPROMPTUSER, EmptyParam, vFmtIs));}
  if vFmtIs <> 'Heading 2' then
    OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT,
                       MSOCMDEXECOPT_DONTPROMPTUSER, 'Heading 2', EmptyParam))
  else
    OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT,
              MSOCMDEXECOPT_DONTPROMPTUSER, 'Normal', EmptyParam));
  ManageAct(iH2);
end;


{H3}
procedure TfrmMSHTMLEdit.actH3Execute(Sender: TObject);
var
  vFmtIs: OleVariant;
begin
  OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT,
                     MSOCMDEXECOPT_DONTPROMPTUSER, EmptyParam, vFmtIs));
  if vFmtIs <> 'Heading 3' then
    OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT,
                       MSOCMDEXECOPT_DONTPROMPTUSER, 'Heading 3', EmptyParam))
  else
    OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT,
                       MSOCMDEXECOPT_DONTPROMPTUSER, 'Normal', EmptyParam));
  ManageAct(iH3);
end;


{H5}
procedure TfrmMSHTMLEdit.actH5Execute(Sender: TObject);
var
  vFmtIs: OleVariant;
begin
  OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT, MSOCMDEXECOPT_DONTPROMPTUSER,
                     EmptyParam, vFmtIs));
  if vFmtIs <> 'Heading 5' then
    OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT, MSOCMDEXECOPT_DONTPROMPTUSER,
                       'Heading 5', EmptyParam))
  else
    OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT, MSOCMDEXECOPT_DONTPROMPTUSER,
                       'Normal', EmptyParam));
  ManageAct(iH5);
end;
*)

{H1}
procedure TfrmMSHTMLEdit.actH1Execute(Sender: TObject);
var
  sText:  string;
  sHTML:  string;
begin
  FSelect := FDocument.selection;
  if SameText(FSelect.type_, 'Text') then
  begin
    FRange := FSelect.CreateRange as IHTMLTxtRange;
    sHTML := Frange.Get_htmlText;
    if iProduct <> iDIS then
      sText := '<h1 style="font-size=large">' +
               sHTML + '</h1>'
    else
      sText := '<h1 style="font-size=large;font-family=sans-serif">' +
               sHTML + '</h1>';
    if iProduct = iSTD then
      sText := '<h1>' + sHTML + '</h1>';
    FRange.pasteHTML(sText);
  end
  else
    ShowMessage('Please select some text first!');
  if assigned(FRange) then
    FRange := nil;
  if assigned(FSelect) then
    FSelect := nil;
  ManageAct(iH1);
end;

{H2}
procedure TfrmMSHTMLEdit.actH2Execute(Sender: TObject);
var
  sText:  string;
  sHTML:  string;
begin
  FSelect := FDocument.selection;
  if SameText(FSelect.type_, 'Text') then
  begin
    FRange := FSelect.CreateRange as IHTMLTxtRange;
    sHTML := Frange.Get_htmlText;
    if iProduct <> iDIS then
      sText := '<h2 style="font-size=medium;font-family=sans-serif">' +
               sHTML + '</h2>'
    else
      sText := '<h2 style="font-size=medium;font-family=sans-serif">' +
               sHTML + '</h2>';
    if iProduct = iSTD then
      sText := '<h2>' + sHTML + '</h2>';
    FRange.pasteHTML(sText);
  end
  else
    ShowMessage('Please select some text first!');
  if assigned(FRange) then
    FRange := nil;
  if assigned(FSelect) then
    FSelect := nil;
  ManageAct(iH2);
end;


{H3}
procedure TfrmMSHTMLEdit.actH3Execute(Sender: TObject);
var
  sText:  string;
  sHTML:  string;
begin
  FSelect := FDocument.selection;
  if SameText(FSelect.type_, 'Text') then
  begin
    FRange := FSelect.CreateRange as IHTMLTxtRange;
    sHTML := Frange.Get_htmlText;
    if iProduct <> iDIS then
      sText := '<h3>' + sHTML + '</h3>'
    else
      sText := '<h3 style="font-size=small;font-family=sans-serif">' +
               sHTML + '</h3>';
    if iProduct = iSTD then
      sText := '<h3>' + sHTML + '</h3>';
    FRange.pasteHTML(sText);
  end
  else
    ShowMessage('Please select some text first!');
  if assigned(FRange) then
    FRange := nil;
  if assigned(FSelect) then
    FSelect := nil;
  ManageAct(iH3);
end;


{H5}
procedure TfrmMSHTMLEdit.actH5Execute(Sender: TObject);
var
  sText:  string;
  sHTML:  string;
begin
  FSelect := FDocument.selection;
  if SameText(FSelect.type_, 'Text') then
  begin
    FRange := FSelect.CreateRange as IHTMLTxtRange;
    sHTML := Frange.Get_htmlText;
    if iProduct <> iDIS then
      sText := '<h5 style="font-size=x-small;font-weight=normal">' +
               sHTML + '</h5>'
    else
      sText := '<h5 style="font-size=x-small;font-weight=normal">' +
               sHTML + '</h5>';
    if iProduct = iSTD then
      sText := '<h5>' + sHTML + '</h5>';
    FRange.pasteHTML(sText);
  end
  else
    ShowMessage('Please select some text first!');
  if assigned(FRange) then
    FRange := nil;
  if assigned(FSelect) then
    FSelect := nil;
  ManageAct(iH5);
end;


{CUT}
procedure TfrmMSHTMLEdit.actCutExecute(Sender: TObject);
begin
  if FDocument.queryCommandEnabled('Cut') then
    OleError(FCommand.Exec(@CGID_MSHTML, IDM_CUT, MSOCMDEXECOPT_DONTPROMPTUSER,
                       EmptyParam, EmptyParam));
  ManageAct(iCut);
end;


{COPY}
procedure TfrmMSHTMLEdit.actCopyExecute(Sender: TObject);
begin
  if FDocument.queryCommandEnabled('Copy') then
    OleError(FCommand.Exec(@CGID_MSHTML, IDM_COPY, MSOCMDEXECOPT_DONTPROMPTUSER,
                       EmptyParam, EmptyParam));
  ManageAct(iCopy);
end;


{Paste}
procedure TfrmMSHTMLEdit.actPasteExecute(Sender: TObject);
begin
  if FDocument.queryCommandEnabled('Paste') then
    OleError(FCommand.Exec(@CGID_MSHTML, IDM_PASTE, MSOCMDEXECOPT_DONTPROMPTUSER,
                       EmptyParam, EmptyParam));
  ManageAct(iPaste);
end;


{Print}
procedure TfrmMSHTMLEdit.actPrintExecute(Sender: TObject);
var
  iVar: OleVariant;
  sStat: string;
begin
  sStat := sbarEdit.Panels[0].Text;
  sbarEdit.Panels[0].Text := 'Printing...';
  iVar := VT_I2;
  OleError(FCommand.Exec(@CGID_MSHTML, IDM_PRINT,
                     MSOCMDEXECOPT_DONTPROMPTUSER, iVar, EmptyParam));
  sbarEdit.Panels[0].Text := sStat;
  ManageAct(iPrint);
end;


{UnDo}
procedure TfrmMSHTMLEdit.actUnDoExecute(Sender: TObject);
begin
  FDocument.execCommand('Undo', False, 0);
  ManageAct(iUnDo);
end;


{ReDo}
procedure TfrmMSHTMLEdit.actReDoExecute(Sender: TObject);
begin
  FDocument.execCommand('Redo', False, 0);
  ManageAct(iReDo);
end;


{Subscript}
procedure TfrmMSHTMLEdit.actSubExecute(Sender: TObject);
begin
  if FDocument.queryCommandEnabled('Subscript') then
    FDocument.execCommand('Subscript', False, 0);
  ManageAct(iSub);
end;


{Superscript}
procedure TfrmMSHTMLEdit.actSuperExecute(Sender: TObject);
begin
  if FDocument.queryCommandEnabled('Superscript') then
    FDocument.execCommand('Superscript', False, 0);
  ManageAct(iSuper);
end;


{Find}
procedure TfrmMSHTMLEdit.actSearchExecute(Sender: TObject);
var
  FSelect:    IHTMLSelectionObject;
begin
  CheckDialog;
  FSelect := FDocument.selection;
  if SameText(FSelect.type_, 'Text') then
  begin
    FRange := FSelect.createRange as IHTMLTxtRange;
    FbHaveSelect := True;
  end
  else
  begin
    FRange := FBody.createTextRange;
    FbHaveSelect := False;
  end;
  if (not assigned(frmFind)) then
    Application.CreateForm(TfrmFind, frmFind);
  frmFind.Show;
  FSelect := nil;
  ManageAct(iFind);
end;


{Find / Replace}
procedure TfrmMSHTMLEdit.actReplaceExecute(Sender: TObject);
var
  FSelect:    IHTMLSelectionObject;
begin
  CheckDialog;
  FSelect := FDocument.selection;
  if SameText(FSelect.type_, 'Text') then
  begin
    FRange := FSelect.createRange as IHTMLTxtRange;
    FbHaveSelect := True;
  end
  else
  begin
    FRange := FBody.createTextRange;
    FbHaveSelect := False;
  end;
  if (not assigned(frmReplace)) then
    Application.CreateForm(TfrmReplace, frmReplace);
  frmReplace.Show;
  FSelect := nil;
  ManageAct(iReplace);
end;

{Go to start of paragraph and insert five &npsp; commands}
procedure TfrmMSHTMLEdit.actIndentExecute(Sender: TObject);
var
  sText:  string;
  sHTML:  string;
begin
  FSelect := FDocument.selection;
  if (SameText(FSelect.type_, 'None')) then
  begin
    FRange := FSelect.CreateRange as IHTMLTxtRange;
    sHTML := Frange.Get_htmlText;
    sText := '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' + sHTML;
    FRange.pasteHTML(sText);
  end
  else
    ShowMessage('Indent paragraph cannot be done here' + CRLF +
                'or within a selection!');
  if assigned(FRange) then
    FRange := nil;
  if assigned(FSelect) then
    FSelect := nil;
  ManageAct(iIndent);
end;


{Put a <pre>...</pre> tag around the selection}
procedure TfrmMSHTMLEdit.actPreExecute(Sender: TObject);
var
  sText:  string;
  sHTML:  string;
begin
  FSelect := FDocument.selection;
  if (SameText(FSelect.type_, 'None')) then
  begin
    FRange := FSelect.CreateRange as IHTMLTxtRange;
    sHTML := Frange.Get_htmlText;
    sText := '<pre> ' + sHTML+ ' </pre>';
    FRange.pasteHTML(sText);
  end
  else
    ShowMessage('Format paragraph cannot be done here' + CRLF +
                'or within a selection!');
  if assigned(FRange) then
    FRange := nil;
  if assigned(FSelect) then
    FSelect := nil;
  ManageAct(iPre);
end;

{
procedure TfrmMSHTMLEdit.actPreExecute(Sender: TObject);
var
  vFmtIs: OleVariant;
begin
  OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT,
                     MSOCMDEXECOPT_DONTPROMPTUSER, EmptyParam, vFmtIs));
  if vFmtIs <> 'Formatted' then
    OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT,
                           MSOCMDEXECOPT_DONTPROMPTUSER, 'Formatted',
                           EmptyParam))
  else
    OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT,
                           MSOCMDEXECOPT_DONTPROMPTUSER, 'Normal',
                           EmptyParam));
  ManageAct(iPre);
end;
}

{Apply 'normal' block format command to selection}
procedure TfrmMSHTMLEdit.actNormalExecute(Sender: TObject);
var
  sText:  string;
  sHTML:  string;
begin
  FSelect := FDocument.selection;
  if (SameText(FSelect.type_, 'None') or SameText(FSelect.type_, 'Text')) then
  begin
    FRange := FSelect.CreateRange as IHTMLTxtRange;
    SelectParagraph;
    sHTML := Frange.Get_Text;
    sText := sHTML;
    FRange.text := sText;
    //OleError(FCommand.Exec(@CGID_MSHTML, IDM_BLOCKFMT,
    //                       MSOCMDEXECOPT_DONTPROMPTUSER, 'Normal', EmptyParam));
  end
  else
    ShowMessage('The remove paragraph style cannot be done here' + CRLF +
                'or within a selection!');
  if assigned(FRange) then
    FRange := nil;
  if assigned(FSelect) then
    FSelect := nil;
  ManageAct(iNormal);
end;


{Unload any child dialogs if we are not in edit mode}
procedure TfrmMSHTMLEdit.CheckDialog;
begin
  if (assigned(frmFind)) then
    if frmfind.Showing then
      frmFind.Close;
  if (assigned(frmReplace)) then
    if frmReplace.Showing then
      frmReplace.Close;
end;


procedure TfrmMSHTMLEdit.actH4Execute(Sender: TObject);
var
  sText:  string;
  sHTML:  string;
begin
  FSelect := FDocument.selection;
  if SameText(FSelect.type_, 'Text') then
  begin
    FRange := FSelect.CreateRange as IHTMLTxtRange;
    sHTML := Frange.Get_htmlText;
    if iProduct <> iDIS then
      sText := '<h4>' + sHTML + '</h4>'
    else
      sText := '<h4 style="font-size=small;font-family=sans-serif">' +
               sHTML + '</h4>';
    if iProduct = iSTD then
      sText := '<h4>' + sHTML + '</h4>';
    FRange.pasteHTML(sText);
  end
  else
    ShowMessage('Please select some text first!');
  if assigned(FRange) then
    FRange := nil;
  if assigned(FSelect) then
    FSelect := nil;
  ManageAct(iH4);
end;

procedure TfrmMSHTMLEdit.FormCreate(Sender: TObject);
begin
  thePath := '';
  ReadOnly := False;
end;

initialization
  OleInitialize(Nil);


finalization
  OleUninitialize;

end.
